<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag bar code generator
	 */

	define ('BASEDIR', '../');
	
	# Defines var for includes re-check

	define ('eBag', TRUE);
	
	# load configuration

	include(BASEDIR.'classes/INIload.class.php');
	
	include(BASEDIR.'classes/Language.class.php');

	$__CONF	= new INI_load(BASEDIR.'conf/eBag.ini');

	# load errorhandler

	include(BASEDIR.'classes/Errorhandler.class.php');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();
	
	# Sets session handler

	include(BASEDIR.'classes/Sessionhandler.class.php');

	$__SESS	= new MysqlSession();
	
	$__SESS	-> set_session_handler();
	
	register_shutdown_function('session_write_close');
	
	# Session check

	session_start();
	
	if ((! isset($_GET['bar_width'])) or ( ! isset($_GET['artical_code'])) or (! isset($_SESSION['permission']))) exit();

	if ((isset($_GET['bar_width'])) && ((integer)$_GET['bar_width'])) $BAR_WIDTH = (integer)$_GET['bar_width'];
	
	# set font file
	
	$path = dirname(dirname(realpath(__FILE__)));
	
	$sep = DIRECTORY_SEPARATOR;
	
	if ($__CONF->get('font', 'directory'))	{
	
		$directory = $path.$sep.'fonts'.$sep.$__CONF->get('font', 'directory');
		  
		if (! is_dir($directory))  {
		
			if (is_dir($__CONF->get('font', 'directory')))	{
			
				$directory = realpath($__CONF->get('font', 'directory'));
			
			}	else	  {
			
				unset($directory);
			}
		}
	}	
	
	if (! isset($directory))	{
			   
		$directory = $path.$sep.'fonts'.$sep.$__CONF->get('font', 'family');
				      
		if (! is_dir($directory)) unset($directory);
	}
	
	if (isset($directory))	{
	
		if (is_readable($directory.$sep.$__CONF->get('font', 'bar_code_font')))	{
		
			define('BAR_FONT_FILE', $directory.$sep.$__CONF->get('font', 'bar_code_font'));
	
		}	elseif (is_readable($directory.$sep.$__CONF->get('font', 'bold_font_file')))	{
		
			define('BAR_FONT_FILE', $directory.$sep.$__CONF->get('font', 'bold_font_file'));
			
		}	elseif (is_readable($directory.$sep.$__CONF->get('font', 'normal_font_file')))  {
		
			define('BAR_FONT_FILE', $directory.$sep.$__CONF->get('font', 'normal_font_file'));
		}
	}

	# draw

	set_time_limit(0);

	switch($_GET['bar_type'])	{

		case('code39'):
		case('code39_e'):		include('code39.class.php');

						$BAR = new CODE39_BAR_CODE;

						if ($_GET['bar_type'] == 'code39_e') $BAR->code39_extended();

						break;

		case('interleaved2of5'):	include('interleaved2of5.class.php');

						$BAR = new INTERLEAVED_2_OF_5_BAR_CODE;

						break;

		case('code128_A'):
		case('code128_B'):
		case('code128_C'):		include('code128.class.php');

						$BAR	=	new CODE128_BAR_CODE;

						$type = explode('_', $_GET['bar_type']);

						$BAR->subset($type[1]);

						break;

		case('upca'):			include('upcA.class.php');

						$BAR = new UPCA_BAR_CODE;

						break;

		case('upce'):			include('upcE.class.php');

						$BAR = new UPCE_BAR_CODE;

						break;

		case('ean13'):			include('ean13.class.php');

						$BAR = new EAN13_BAR_CODE;

						break;

		case('ean8'):			include('ean8.class.php');

						$BAR = new EAN8_BAR_CODE;

						break;
	}

	if (! isset($BAR)) exit;

	if (get_magic_quotes_gpc())	$_GET['artical_code'] = stripslashes($_GET['artical_code']);
	
	$BAR->code($_GET['artical_code']);

	if (isset($BAR_WIDTH)) $BAR->width($BAR_WIDTH);	

	if ((isset($_GET['height'])) && ((integer)$_GET['height'])) $BAR->height($_GET['height']);

	if ((isset($_GET['padding'])) && ((integer)$_GET['padding'])) $BAR->padding($_GET['padding']);

	if ((isset($_GET['print_code'])) && ($_GET['print_code']))	{

		$BAR	->	print_code();

		$BAR	->	font_size($_GET['font_size']);
	}

	if (! $BAR -> generate())	{
	
		$lang = strtolower($__CONF->get('language', 'lang'));

		$__LANG	= new Lang(BASEDIR."lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));

		$MESSAGE = $__LANG->get('invalidbarcodechar').' ('.$_GET['artical_code'].')';

		include(BASEDIR.'views/printqueryempty.php');
	}

?>
