<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * Code39 (extended) bar code image generator
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class CODE39_BAR_CODE	{

		var $CODE;

		var $EXTENDED		=	FALSE;

		var $PRINT_CODE_STRING	=	FALSE;

		var $BAR_DEFINITION	=	'';

		var $SCALE_FACTOR	=	1;

		var $NARROW_WIDTH_RATIO	=	2.5;

		var $NARROW_BAR_WIDTH	=	2;

		var $BAR_CODE_HEIGHT	=	0;

		var $PADDING		=	10;

		var $FONT_SIZE		=	10;

		var $FONT_FILE		=	FALSE;

		# Code 39 Extended character set

		var $CODE39_EXTENDED_CHARS	=	array (	'NUL' 		=>	'%U',
								'SOH' 		=>	'$A',
								'STX' 		=>	'$B',
								'ETX' 		=>	'$C',
								'EOT' 		=>	'$D',
								'ENQ' 		=>	'$E', 
								'ACK' 		=>	'$F',
								'BEL' 		=>	'$G',
								'BS' 		=>	'$H',
								'HT' 		=>	'$I',
								'LF' 		=>	'$J',
								'VT' 		=>	'$K',
								'FF' 		=>	'$L',
								'CR' 		=>	'$M',
								'SO' 		=>	'$N', 
								'SI' 		=>	'$O', 
								'DLE' 		=>	'$P', 
								'DC1' 		=>	'$Q', 
								'DC2' 		=>	'$R',
								'DC3' 		=>	'$S', 
								'DC4' 		=>	'$T', 
								'NAK' 		=>	'$U', 
								'SYN' 		=>	'$V', 
								'ETB' 		=>	'$W', 
								'CAN' 		=>	'$X', 
								'EM' 		=>	'$Y', 
								'SUB' 		=>	'$Z', 
								'ESC' 		=>	'%A', 
								'FS' 		=>	'%B', 
								'GS' 		=>	'%C', 
								'RS' 		=>	'%D', 
								'US' 		=>	'%E', 
								' ' 		=>	' ',
								'!' 		=>	'/A',
								'"' 		=>	'/B',
								'#' 		=>	'/C', 
								'$' 		=>	'/D', 
								'%' 		=>	'/E', 
								'&'		=>	'/F', 
								'\'' 		=>	'/G',
								'(' 		=>	'/H', 
								')' 		=>	'/I', 
								'*' 		=>	'/J', 
								'+' 		=>	'/K', 
								',' 		=>	'/L', 
								'-' 		=>	'-', 
								'.' 		=>	'.', 
								'/' 		=>	'/O', 
								'0' 		=>	'0', 
								'1' 		=>	'1', 
								'2' 		=>	'2', 
								'3' 		=>	'3', 
								'4' 		=>	'4', 
								'5' 		=>	'5', 
								'6' 		=>	'6', 
								'7'		=>	'7', 
								'8' 		=>	'8', 
								'9' 		=>	'9', 
								':' 		=>	'/Z', 
								';' 		=>	'%F',
								'<' 		=>	'%G', 
								'=' 		=>	'%H', 
								'>' 		=>	'%I', 
								'?' 		=>	'%J', 
								'@' 		=>	'%V', 
								'A' 		=>	'A', 
								'B' 		=>	'B', 
								'C' 		=>	'C', 
								'D' 		=>	'D', 
								'E' 		=>	'E', 
								'F' 		=>	'F', 
								'G' 		=>	'G', 
								'H' 		=>	'H', 
								'I' 		=>	'I', 
								'J' 		=>	'J', 
								'K' 		=>	'K', 
								'L' 		=>	'L', 
								'M' 		=>	'M',
								'N' 		=>	'N',
								'O' 		=>	'O',
								'P' 		=>	'P',
								'Q' 		=>	'Q',
								'R' 		=>	'R',
								'S' 		=>	'S',
								'T' 		=>	'T',
								'U' 		=>	'U',
								'V' 		=>	'V',
								'W' 		=>	'W',
								'X' 		=>	'X',
								'Y' 		=>	'Y',
								'Z' 		=>	'Z',
								'[' 		=>	'%K', 
								'\'' 		=>	'%L', 
								']' 		=>	'%M', 
								'^' 		=>	'%N', 
								'_' 		=>	'%O', 
								'`' 		=>	'%W',
								'a' 		=>	'+A',
								'b' 		=>	'+B',
								'c' 		=>	'+C',
								'd' 		=>	'+D',
								'e' 		=>	'+E',
								'f' 		=>	'+F',
								'g' 		=>	'+G',
								'h' 		=>	'+H',
								'i' 		=>	'+I',
								'j' 		=>	'+J',
								'k' 		=>	'+K',
								'l' 		=>	'+L',
								'm' 		=>	'+M',
								'n' 		=>	'+N',
								'o' 		=>	'+O',
								'p' 		=>	'+P',
								'q' 		=>	'+Q',
								'r' 		=>	'+R',
								's' 		=>	'+S',
								't' 		=>	'+T',
								'u' 		=>	'+U',
								'v' 		=>	'+V',
								'w' 		=>	'+W',
								'x' 		=>	'+X',
								'y' 		=>	'+Y',
								'z' 		=>	'+Z',
								'{' 		=>	'%P',
								'|' 		=>	'%Q',
								'}' 		=>	'%R',
								'~' 		=>	'%S',
								'DEL' 		=>	'%T'	);

		# Code39 bar definitions

		var $CODE39_BAR_DEFINITONS =	array	(	'0' 		=>	'bwbWBwBwb',
								'1' 		=>	'BwbWbwbwB',
								'2' 		=>	'bwBWbwbwB',
								'3' 		=>	'BwBWbwbwb',
								'4' 		=>	'bwbWBwbwB',
								'5' 		=>	'BwbWBwbwb',
								'6' 		=>	'bwBWBwbwb',
								'7' 		=>	'bwbWbwBwB',
								'8' 		=>	'BwbWbwBwb',
								'9' 		=>	'bwBWbwBwb',
								'A' 		=>	'BwbwbWbwB',
								'B' 		=>	'bwBwbWbwB',
								'C' 		=>	'BwBwbWbwb',
								'D' 		=>	'bwbwBWbwB',
								'E' 		=>	'BwbwBWbwb',
								'F' 		=>	'bwBwBWbwb',
								'G' 		=>	'bwbwbWBwB',
								'H' 		=>	'BwbwbWBwb',
								'I' 		=>	'bwBwbWBwb',
								'J' 		=>	'bwbwBWBwb',
								'K' 		=>	'BwbwbwbWB',
								'L' 		=>	'bwBwbwbWB',
								'M' 		=>	'BwBwbwbWb',
								'N' 		=>	'bwbwBwbWB',
								'O' 		=>	'BwbwBwbWb',
								'P' 		=>	'bwBwBwbWb',
								'Q' 		=>	'bwbwbwBWB',
								'R' 		=>	'BwbwbwBWb',
								'S' 		=>	'bwBwbwBWb',
								'T' 		=>	'bwbwBwBWb',
								'U' 		=>	'BWbwbwbwB',
								'V' 		=>	'bWBwbwbwB',
								'W' 		=>	'BWBwbwbwb',
								'X' 		=>	'bWbwBwbwB',
								'Y' 		=>	'BWbwBwbwb',
								'Z' 		=>	'bWBwBwbwb',
								'-' 		=>	'bWbwbwBwB',
								'.' 		=>	'BWbwbwBwb',
								' ' 		=>	'bWBwbwBwb',
								'$' 		=>	'bWbWbWbwb',
								'/' 		=>	'bWbWbwbWb',
								'+' 		=>	'bWbwbWbWb',
								'%' 		=>	'bwbWbWbWb',
								'*' 		=>	'bWbwBwBwb'	);
								
		function __construct()	{
		
			if (defined('BAR_FONT_FILE')) $this->FONT_FILE = BAR_FONT_FILE;
		}

		public function code($string = FALSE)	{

			if ($string) $this->CODE = $string;
		}

		public function code39_extended()	{

			$this->EXTENDED = TRUE;
		}

		public function scale($factor = FALSE)	{

			if ($factor > 1) $this->SCALE_FACTOR = $factor;
		}

		public function width($pixel = FALSE)	{

			if ((integer)$pixel > 0) $this->NARROW_BAR_WIDTH = (integer)$pixel;
		}

		public function height($height = FALSE)	{

			if ($height > 0) $this->BAR_CODE_HEIGHT = $height;
		}

		public function padding($padding = FALSE)	{

			if ($padding > 0) $this->PADDING = $padding;
		}

		public function print_code()	{

			if ($this->FONT_FILE) $this->PRINT_CODE_STRING = TRUE;
		}

		public function font_size($size)	{

			if ($size > 5) $this->FONT_SIZE = $size;
		}

		public function generate()	{

			if (! $this->CODE) return FALSE;

			# generate definition

			if (! $this->generate_bar_definition()) return FALSE;

			# set the scale factor

			$this->NARROW_BAR_WIDTH = (integer)($this->NARROW_BAR_WIDTH * $this->SCALE_FACTOR);

			# calculate width

			$this->calculate_bar_dimensions();

			# draw the bar code

			$this->draw_bar();

			return TRUE;
		}

		private function replace_ascii_conroll_char($char)	{

			$conroll_chars	=	array	(
								chr(0)	=>	'NUL', 
								chr(1)	=>	'SOH', 
								chr(2)	=>	'STX', 
								chr(3)	=>	'ETX', 
								chr(4)	=>	'EOT', 
								chr(5)	=>	'ENQ', 
								chr(6)	=>	'ACK',
								chr(7)	=>	'BEL', 
								chr(8)	=>	'BS',
								chr(9)	=>	'HT',
								chr(10)	=>	'LF',
								chr(11) =>	'VT', 
								chr(12) =>	'FF',
								chr(13) =>	'CR',
								chr(14) =>	'SO',
								chr(15) =>	'SI',
								chr(16) =>	'DLE',
								chr(17) =>	'DC1',
								chr(18) =>	'DC2', 
								chr(19) =>	'DC3', 
								chr(20) =>	'DC4',
								chr(21) =>	'NAK', 
								chr(22) =>	'SYN',
								chr(23) =>	'ETB', 
								chr(24) =>	'CAN', 
								chr(25) =>	'EM',
								chr(26) =>	'SUB',
								chr(27) =>	'ESC', 
								chr(28) =>	'FS', 
								chr(29) =>	'GS', 
								chr(30) =>	'RS',
								chr(31) =>	'US', 
								chr(32) =>	' ',
								chr(127)=>	'DEL'
							);

			if (isset($conroll_chars[$char])) return $conroll_chars[$char];

			return $char;
		}

		private function generate_bar_definition()	{

			$length	= strlen($this->CODE);

			$EXTENDED_CODE	=	'';

			for ($i=0; $i<$length; $i++)	{

				$char = substr($this->CODE, $i, 1);

				$char = $this->replace_ascii_conroll_char($char);

				if ((! $this->EXTENDED) && (! isset($this->CODE39_BAR_DEFINITONS[$char])))	{

					$error = TRUE;

					break;
				}

				if (isset($this->CODE39_EXTENDED_CHARS[$char]))	  {

					$EXTENDED_CODE .= $this->CODE39_EXTENDED_CHARS[$char];

				}	else	  {

					$error = TRUE;

					break;
				}
			}

			if ((isset($error)) or (! $EXTENDED_CODE)) return FALSE;

			$length	= strlen($EXTENDED_CODE);

			for ($i=0; $i<$length; $i++)	{

				$char = substr($EXTENDED_CODE, $i, 1);

				if (isset($this->CODE39_BAR_DEFINITONS[$char]))	  {

					$this->BAR_DEFINITION .= 'w'.$this->CODE39_BAR_DEFINITONS[$char];

				}	else	  {

					$error = TRUE;

					break;
				}
			}

			if ((isset($error)) or (! $this->BAR_DEFINITION)) return FALSE;

			# Code39 bar code start with *w and ends with w*

			$this->BAR_DEFINITION = $this->CODE39_BAR_DEFINITONS['*'].'w'.$this->BAR_DEFINITION.'w'.$this->CODE39_BAR_DEFINITONS['*'];

			return TRUE;
		}

		private function calculate_bar_dimensions()	{

			$this->LENGTH	= strlen($this->BAR_DEFINITION);

			$this->BAR_CODE_WIDTH	=	0;

			$this->WIDE_BAR_WIDTH = (integer)($this->NARROW_BAR_WIDTH * $this->NARROW_WIDTH_RATIO);

			for ($i=0; $i<$this->LENGTH; $i++)	{

				$def	=	substr($this->BAR_DEFINITION, $i, 1);

				if (($def=='B') or ($def=='W')) {

					$this->BAR_CODE_WIDTH += $this->WIDE_BAR_WIDTH;

				}	else	  {

					$this->BAR_CODE_WIDTH += $this->NARROW_BAR_WIDTH;
				}
			}

			if (! $this->BAR_CODE_HEIGHT)  $this->BAR_CODE_HEIGHT = (integer)($this->BAR_CODE_WIDTH * 15/100);
		}

		private function draw_bar()	{

			# Calculate code string coords

			if ($this->PRINT_CODE_STRING)	{

				$box   = imagettfbbox($this->FONT_SIZE, 0, $this->FONT_FILE, "* $this->CODE *");

				$min_x = min( array($box[0], $box[2], $box[4], $box[6]) );
				$max_x = max( array($box[0], $box[2], $box[4], $box[6]) );
				$min_y = min( array($box[1], $box[3], $box[5], $box[7]) );
				$max_y = max( array($box[1], $box[3], $box[5], $box[7]) );

				$code_string_width  = ( $max_x - $min_x );
				$code_string_height = ( $max_y - $min_y ) + 5; 

			}	else	  {

				$code_string_height = 0; 
			}

			# Create image

			$image_width	=	$this->BAR_CODE_WIDTH + 2 * $this->PADDING;

			$image_height	=	$this->BAR_CODE_HEIGHT + 2 * $this->PADDING + $code_string_height;

			$image = imagecreate($image_width, $image_height);

			$white = imagecolorallocate($image, 255, 255, 255);

			imagefill($image, 0, 0, $white);

			# Draw the bars

			$black = imagecolorallocate($image, 0, 0, 0);

			$X_COOR = $this->PADDING;

			for ($i=0; $i<$this->LENGTH; $i++)	{

				$def	=	substr($this->BAR_DEFINITION, $i, 1);

				switch ($def)	{

					case('b')	:	imagefilledrectangle($image, $X_COOR, $this->PADDING, $X_COOR + $this->NARROW_BAR_WIDTH -1, $this->BAR_CODE_HEIGHT+$this->PADDING, $black);

								$X_COOR += $this->NARROW_BAR_WIDTH;

								break;

					case('B')	:	imagefilledrectangle($image, $X_COOR, $this->PADDING, $X_COOR + $this->WIDE_BAR_WIDTH - 1, $this->BAR_CODE_HEIGHT + $this->PADDING, $black);

								$X_COOR += $this->WIDE_BAR_WIDTH;

								break;

					case('w')	:	$X_COOR += $this->NARROW_BAR_WIDTH;

								break;

					case('W')	:	$X_COOR += $this->WIDE_BAR_WIDTH;

								break;
				}
			}

			# Print code

			if ($this->PRINT_CODE_STRING)	imagettftext( $image, $this->FONT_SIZE, 0, (integer)(($image_width-$code_string_width)/2), $this->BAR_CODE_HEIGHT + $this->PADDING + $code_string_height, $black, $this->FONT_FILE, "* $this->CODE *");

			# Output

			header('Pragma: no-cache');
			header('Cache-Control: no-cache, no-store, must-revalidate');
			header('Expires: Sun, 10 Jan 2010 12:00:00 GMT');
			header('Last-Modified: '.@gmdate('D, d M Y H:i:s').' GMT');
			header('Content-type: image/png');

			imagepng($image);

			imagedestroy($image);
		}
	}
?>
