<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag bill print
	 */

	load_f('id_explode');
	
	load_f('explode_textarea');

	class BILLPRINT	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');
			
			$this->FONT_FAMILY = 	$__CONF->get('font', 'family');
			
			$this->FONT_N_FILE = 	$__CONF->get('font', 'normal_font_file');
			
			$this->FONT_B_FILE = 	$__CONF->get('font', 'bold_font_file');
			
			if ($this->FONT_B_FILE) {$this->BOLD = 'B';} else {$this->BOLD = '';}
		}

		public function year($YEAR=FALSE)	{

			if ($YEAR) $this->BASE = "ebagdata$YEAR";
		}

		private function lock()	{

			$this->SQL->query(" LOCK TABLES	$this->BASE.bills_header WRITE, $this->BASE.bills_data WRITE,
							$this->BASE.services_data WRITE, $this->BASE.deliverys_data WRITE,
							ebag.companydata WRITE ");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function setpage()	{

			if ($this->FONT_N_FILE) $this->PDF->AddFont($this->FONT_FAMILY,'',$this->FONT_N_FILE,true);
			if ($this->FONT_B_FILE) $this->PDF->AddFont($this->FONT_FAMILY,$this->BOLD,$this->FONT_B_FILE,true);

			$this->PDF->AliasNbPages();

			$this->PDF->SetCreator('eBag-TFPDF');
			$this->PDF->SetSubject($this->LANG->get('bill'));
			$this->PDF->SetTitle($this->LANG->get('bill'));

			$this->PDF->SetTextColor(0);
			$this->PDF->SetDrawColor(0);
			$this->PDF->SetFillColor(255);
			$this->PDF->SetMargins(20, 10, 20, 10);
		}

		private function tableheader()	{

			$this->PDF->SetFillColor(204, 204, 204);
		
			$this->PDF->SetFont($this->FONT_FAMILY, $this->BOLD, 7);

			$this->PDF->eCell(10, 6, $this->LANG->get('personID'), 1, 0, 'C', 1);
			$this->PDF->eCell(33, 6, $this->LANG->get('code'), 1, 0, 'C', 1);
			$this->PDF->eCell(84, 6, $this->LANG->get('name'), 1, 0, 'C', 1);
			$this->PDF->eCell(15, 6, $this->LANG->get('quantity_short'), 1, 0, 'C', 1);
			$this->PDF->eCell(15, 6, $this->LANG->get('unit_short'), 1, 0, 'C', 1);
			$this->PDF->eCell(20, 6, $this->LANG->get('unit_price_short'), 1, 0, 'C', 1);
			$this->PDF->eCell(20, 6, $this->LANG->get('sum'), 1, 0, 'C', 1);
			$this->PDF->eCell(20, 6, $this->LANG->get('columnname_tax').' %', 1, 0, 'C', 1);
			$this->PDF->eCell(20, 6, $this->LANG->get('columnname_tax'), 1, 0, 'C', 1);
			$this->PDF->eCell(20, 6, $this->LANG->get('sum').' + '.$this->LANG->get('columnname_tax'), 1, 0, 'C', 1);
			$this->PDF->Ln(6);
			
			$this->PDF->SetFont($this->FONT_FAMILY, '', 7);
		}

		private function createpage($ID)	{

			$this->PDF->AddPage();

			$this->PDF->PAGE_NUMBER = 1;

			# Read company ID & check existens 
			
			$this->SQL->query("	SELECT `companyID` 
						FROM $this->BASE.bills_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
						
			if (! $this->SQL->num_rows()) return 0;
			
			# read company data (not must to be the same)
			
			list($companyID) = $this->SQL->RESULT->fetch_row();

			$this->SQL->query("	SELECT 	`companyname`, `country`, `city`, `zip`, `street`, `telephone1`, 
							`fax`, `mail`, `website`, `account1`, `bank1`, `tax_id_number` 
						FROM ebag.companydata 
						WHERE `personID`= '$companyID' LIMIT 1	");

			$COMPANY = $this->SQL->RESULT->fetch_assoc();

			foreach ($COMPANY as $key=>$val) $COMPANY[$key] = htmlspecialchars_decode($val, ENT_COMPAT);

			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,9);

			$this->PDF->eCell(0, 10, $COMPANY['companyname'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->SetFont($this->FONT_FAMILY,'',9);	

			$this->PDF->eCell(0, 10, $COMPANY['country'].', '.$COMPANY['city'].' '.$COMPANY['zip'].', '.$COMPANY['street'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $this->LANG->get('telephone').': '.$COMPANY['telephone1'].' '.$this->LANG->get('fax').': '.$COMPANY['fax'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $COMPANY['mail'].'  '.$COMPANY['website'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $this->LANG->get('account').': '.$COMPANY['account1'].' '.$COMPANY['bank1'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $this->LANG->get('taxidno').': '.$COMPANY['tax_id_number'], 0, 0, 'L', 0);

			unset($COMPANY);
			
			# read customers data

			$this->SQL->query("	SELECT 	`contactname`, `country`, `city`, `zip`, `street`, `annotation`,  
							 DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							`currency`, `payment_form`  
					  	FROM $this->BASE.bills_header WHERE personID='$ID' LIMIT 1");

			$HEADER	=	$this->SQL->RESULT->fetch_assoc();

			$CONVERT	=	array('contactname', 'country', 'city', 'zip', 'street', 'currency', 'annotation');

			foreach ($CONVERT as $key) $HEADER[$key] = htmlspecialchars_decode($HEADER[$key], ENT_COMPAT);

			$this->PDF->eSetX(160);
			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,9);	
			$this->PDF->eCell(0, 10, $HEADER['contactname'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eSetX(160);	

			$this->PDF->SetFont($this->FONT_FAMILY,'',9);	
			$this->PDF->eCell(0, 10, $HEADER['country'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eSetX(160);	
			$this->PDF->eCell(0, 10, $HEADER['zip'].'  '.$HEADER['city'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eSetX(160);	
			$this->PDF->eCell(0, 10, $HEADER['street'],0, 0, 'L', 0);

			$this->PDF->Ln(6);

			# read bills data 

			$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `tax`, `dataID`, `datatype`
						FROM $this->BASE.bills_data
						WHERE `billID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

			$NUM_ROWS	=	$this->SQL->num_rows();

			# add title

			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,10);
			$this->PDF->Ln(6);

			$this->PDF->PAGE_TITLE = $this->LANG->get('billnumber_pdf', "$ID/".str_replace('ebagdata', '', $this->BASE));

			$this->PDF->eCell(0, 10, $this->PDF->PAGE_TITLE, 0, 0, 'L', 0);
			$this->PDF->Ln(16);

			# fetch data, calculate prices & create sums

			$this->PDF->SetFont($this->FONT_FAMILY, '', 7);

			# note: price in bill table are real prices without tax

			$PRICE_SUM = $PRICE_TAX = $PRICE_SUM_TAX = $LINE_NO = 0;

			$CONNECTED_WITH	= '';

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				# convert & calculate

				$CODE		=	htmlspecialchars_decode($IT1_RESULT['code'], ENT_COMPAT);
				$NAME		=	htmlspecialchars_decode($IT1_RESULT['name'], ENT_COMPAT);
				$UNIT		=	htmlspecialchars_decode($IT1_RESULT['unit'], ENT_COMPAT);

				$QUANTITY	=	$IT1_RESULT['quantity'];

				$PRICE		=	$IT1_RESULT['price'];
				
				$SUM		=	$PRICE*$QUANTITY;
				
				$TAX		=	$SUM * $IT1_RESULT['tax']/100;
						
				$SUM_TAX	=	$SUM + $TAX;
	
				$PRICE_P	=	number_format($PRICE, 2, '.', '');

				$SUM_P		=	number_format($SUM, 2, '.', '');

				$TAX_P		=	number_format($IT1_RESULT['tax'], 2, '.', '');
				
				$TAX_VALUE_P	=	number_format($TAX, 2, '.', '');
				
				$SUM_TAX_P	=	number_format($SUM_TAX, 2, '.', '');
				
				$PRICE_TAX	+=	$TAX;
						
				$PRICE_SUM_TAX	+=	$SUM_TAX;

				$PRICE_SUM	+=	$SUM;

				if (! $LINE_NO) $this->tableheader();

				# read origin

				# note:	datatype d=>delivery, s=>service
				#	error can not be occur, however if somehow happends
				#	to not print false bill, breaks the loop & return 

				$dataID		=	$IT1_RESULT['dataID'];

				if ($IT1_RESULT['datatype'] == 's')	{

					$this->SQL->query("	SELECT `reversID`
								FROM $this->BASE.services_data
								WHERE `personID`='$dataID' LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$RESULT = $this->SQL->RESULT->fetch_row();

						$CONNECTED_WITH_NEW = $this->LANG->get('reversnumber').' '.$RESULT[0];

					}	else	  {

						$error = TRUE;

						break;
					}
				}

				if ($IT1_RESULT['datatype'] == 'd')	{

					$this->SQL->query("	SELECT `deliveryID` 
								FROM $this->BASE.deliverys_data
								WHERE `personID`='$dataID' LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$RESULT = $this->SQL->RESULT->fetch_row();

						$CONNECTED_WITH_NEW = $this->LANG->get('deliverynumber').' '.$RESULT[0];

					}	else	  {

						$error = TRUE;

						break;
					}
				}

				if ($CONNECTED_WITH != $CONNECTED_WITH_NEW)	{

					$CONNECTED_WITH = $CONNECTED_WITH_NEW;

					$this->PDF->eCell(257, 6, $CONNECTED_WITH.'/'.str_replace('ebagdata', '', $this->BASE), 'TLR', 0, 'L', 0);

					$this->PDF->Ln(6);
				}

				# print table data

				$this->PDF->eCell(10, 6, ' '.($LINE_NO+1), 'L', 0, 'L', 0);	
				$this->PDF->eCell(33, 6, " $CODE", '', 0, 'L', 0);
				$this->PDF->eCell(84, 6, " $NAME", '', 0, 'L', 0);
				$this->PDF->eCell(15, 6, " $QUANTITY",'', 0, 'L', 0);
				$this->PDF->eCell(15, 6, " $UNIT", '', 0, 'L', 0);
				$this->PDF->eCell(20, 6, " $PRICE_P", '', 0, 'L', 0);
				$this->PDF->eCell(20, 6, " $SUM_P", '', 0, 'L', 0);
				$this->PDF->eCell(20, 6, " $TAX_P", '', 0, 'L', 0);
				$this->PDF->eCell(20, 6, " $TAX_VALUE_P", '', 0, 'L', 0);
				$this->PDF->eCell(20, 6, " $SUM_TAX_P", 'R', 0, 'L', 0);
				$this->PDF->Ln(6);

				$LINE_NO++;

				$Y_COORD = $this->PDF->GetY();

				if (	(($this->PDF->h-$Y_COORD <= 66) && ($NUM_ROWS-$LINE_NO<7) && ($NUM_ROWS != $LINE_NO))	or 
					(($this->PDF->h-$Y_COORD <= 20) && ($NUM_ROWS != $LINE_NO))	)	{

					$this->PDF->eCell(257, 6,'','T', 0, 'C', 0);
					$this->PDF->AddPage();
					$this->tableheader();
				}

				if ($NUM_ROWS == $LINE_NO) $this->PDF->eCell(257, 6,'','T', 0, 'C', 0);
			}

			if (isset($error)) return FALSE;

			# print sums

			$PRICE_SUM	=	number_format($PRICE_SUM, 2, '.', '');
			$PRICE_TAX	=	number_format($PRICE_TAX, 2, '.', '');
			$PRICE_SUM_TAX	=	number_format($PRICE_SUM_TAX, 2, '.', '');

			$this->PDF->Ln(2);
			$this->PDF->eSetX(187);
			$this->PDF->eCell(60, 6, $this->LANG->get('sumpricewithouttax').' ', 0, 0, 'R', 0);
			$this->PDF->eCell(30, 6, " $PRICE_SUM ".$HEADER['currency'], 0, 0, 'R', 0);
			$this->PDF->Ln(6);
			$this->PDF->eSetX(187);
			$this->PDF->eCell(60, 6, $this->LANG->get('tax'), 0, 0, 'R', 0);
			$this->PDF->eCell(30, 6, " $PRICE_TAX ".$HEADER['currency'], 0, 0, 'R', 0); 
			$this->PDF->Ln(6);
			$this->PDF->eSetX(187);
			$this->PDF->eCell(60, 6, $this->LANG->get('sumpricewithtax').' ',0, 0, 'R', 0);
			$this->PDF->eCell(30, 6, " $PRICE_SUM_TAX ".$HEADER['currency'], 0, 0, 'R', 0);

			# payment form

			if (isset($this->PAYMENT_FORMS[$HEADER['payment_form']])) $HEADER['payment_form'] = htmlspecialchars_decode($this->PAYMENT_FORMS[$HEADER['payment_form']], ENT_COMPAT);

			$this->PDF->Ln(6);
			$this->PDF->eSetX(217);
			$this->PDF->eCell(60, 6, $this->LANG->get('payment_name').': '.$HEADER['payment_form'].' . ', 0, 0, 'R', 0);

			$this->PDF->Ln(4); 
			$this->PDF->eSetX(217);
			$this->PDF->eCell(60, 6, $this->LANG->get('date_of_creation').' : '.$HEADER['date_of_creation'].' ', 0, 0, 'R', 0);
			
			# annotation
			
			if ($LINES = explode_textarea($HEADER['annotation']))	  {
				
				foreach ($LINES as $LINE)	{

					$this->PDF->Ln(4);
					$this->PDF->eSetX(217);
					$this->PDF->eCell(0, 6, $LINE, 0, 0, 'R', 0);
				}
			}

			# print row for signature

			$Y_COORD = $this->PDF->GetY();

			if ($this->PDF->h-$Y_COORD > 90) $this->PDF->SetY($Y_COORD+22);

			$this->PDF->Ln(20);
			$this->PDF->eSetX(230);
			$this->PDF->eCell(40, 6, $this->LANG->get('billcreatedby'), 'T', 0, 'C', 0);

			return TRUE;
		}

		public function pdfprint($ID_s)	{

			# create usable array

			if (! $ID_s = id_explode($ID_s)) return FALSE;

			# first check te gived base exists or not

			$this->SQL->query("	SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;
			
			# read payments
			
			$__PAYMENTS		=	new PAYMENTloader($this->APC);

			$this->PAYMENT_FORMS	=	$__PAYMENTS->getnames();

			unset($__PAYMENTS);

			$this->IDs	=	array();

			foreach ($ID_s as $ID)	{

				$this->SQL->query("	SELECT `companyID`
							FROM $this->BASE.bills_header
							WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows()) $this->IDs[] = $ID;
			}
			
			if (! count($this->IDs)) return FALSE;

			# set time limit

			set_time_limit(0);

			# create object

			$this->PDF = new ePDF('L','mm','A4');
			
			if (defined('TEXT_DIRECTION') && (TEXT_DIRECTION == 'rtl')) $this->PDF->RTL = TRUE;

			# sets elementary page data

			$this->setpage();
			
			$printed = $error = FALSE;

			foreach ($this->IDs as $ID) {
			
				$this->lock();
				
				$result = $this->createpage($ID);
				
				if ($result === FALSE) {
				
					$error = TRUE; break;
				}  
				
				if ($result) $printed = TRUE;
				
				$this->unlock();
				
				usleep(300000);
			}
			
			if (! $printed) return FALSE;

			if ($error) return 'damagedbill';

			# force download

			$this->PDF->Output('printed.pdf', 'D');

			return TRUE;
		}
	}

?>

