<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag list of deadline expired claims
	 */

	load_f('pagination');

	load_f('mb_wrap');

	load_f('date2sql');

	class EXPIREDCLAIMS	{

		var $SUMMARY		=	array();
		var $TABLE		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $COMMAND		=	'';

		var $COLUMN_names	=	array(	'billID', 'date_of_creation', 'payment_deadline', 'contactname', 'city', 'sum', 'baseyear' );

		var $COLUMN_names_AS	=	array();

		var $FILTER_type	=	array(	'billID'=>'none', 'date_of_creation'=>'date', 'payment_deadline'=>'date', 
							'contactname'=>'box', 'city'=>'box', 'sum'=>'box', 'baseyear'=>'none'	);


		function __construct($INCREMENT)	{

			$this->INC	=	$INCREMENT;

			$this->BASE	=	$_SESSION['BASE'];

			global $__SQL, $__CONF, $__LANG, $__BOX;

			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->PHPFORMAT=	$__CONF->get('date', 'dateformat');
			
			$this->BOX	=	&$__BOX;

			$this->LANG	=	&$__LANG;

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				$this->FILTER_state[$COLUMN]	=	FALSE;
				$this->COLUMN_names_AS[$COLUMN] = 	$this->LANG->get($COLUMN);

				if ($COLUMN == 'sum') $this->COLUMN_names_AS[$COLUMN] .= '('.$__CONF->get('payments', 'currency').')';
			}
		}

		/**
		 *	form command to sql
		 */

		private function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				$today	=	date("Y-m-d");

				$SEARCH	= '';

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((! isset($this->FILTER_state[$COLUMN])) or (! $this->FILTER_state[$COLUMN]))  continue;

					switch ($this->FILTER_type[$COLUMN])	{

						case('box')	:	$SEARCH	.= " AND `$COLUMN` REGEXP '".($this->SQL->s_escape($this->FILTER_state[$COLUMN], 'REGEXP'))."' ";

									break;

						case('date')	:	$DATE = explode('/', $this->FILTER_state[$COLUMN]);

									if ($DATE[0]!='-') $SEARCH .= " AND DAY($COLUMN)=".$DATE[0].' ';

									if ($DATE[1]!='-') $SEARCH .= " AND MONTH($COLUMN)=".$DATE[1].' ';

									if ($DATE[2]!='-') $SEARCH .= " AND YEAR($COLUMN)=".$DATE[2].' ';

									unset($DATE);
	
									break;

						default		:	continue;
					}

				}

				$this->COMMAND = "	SELECT SQL_CALC_FOUND_ROWS  	`billID`, 
											DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`, 
											DATE_FORMAT(`payment_deadline`, '$this->FORMAT') AS `payment_deadline`, 
											`contactname`, `city`, `sum`, `baseyear` 
							FROM $this->BASE.claims
							WHERE `payment_deadline` < '$today' $SEARCH ORDER BY `billID` DESC	";

				$_SESSION['COMMAND'] = $this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->ROW_LABEL .= "<td $CLASS>".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->ROW_LABEL	.=	'<td class="filters" rowspan="2">'."\n"
						 	.'<input class="button-list" type="submit" name="FILTER" value="'.$this->LANG->get('filter').'">'."\n"
							.'</td><td class="filters" rowspan="2">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n";

			$this->ROW_LABEL	.=	'</tr>'."\n";
		}

		/**
		 * Create tabe row with filters
		 */

		private function TABLEFILTERS()	{

			$this->ROW_FILTER	.=	'<tr class="list-filters">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				$VALUE	=	'';

				if ($this->FILTER_type[$COLUMN]=='none') $this->ROW_FILTER .= '<td></td>'."\n";

				# Adds box or date box

				if (($this->FILTER_type[$COLUMN] == 'box') or ($this->FILTER_type[$COLUMN] == 'date'))	{

					if ($this->FILTER_type[$COLUMN] == 'date')	{

						if ($this->FILTER_state[$COLUMN])	{

							$DATE	=	explode('/', $this->FILTER_state[$COLUMN]);

							if ($DATE[0] != '-') {$DATE[0]='d'.$DATE[0];} else {$DATE[0]='';}
							if ($DATE[1] != '-') {$DATE[1]='m'.$DATE[1];} else {$DATE[1]='';}
							if ($DATE[2] != '-') {$DATE[2]='y'.$DATE[2];} else {$DATE[2]='';}

							$VALUE	= $DATE[0].$DATE[1].$DATE[2];
						}

					}	else	{

						$VALUE	= $this->FILTER_state[$COLUMN];

					}
						
					if ($COLUMN == 'orderID') {$CLASS = 'filter-input-mini';} else {$CLASS = 'filter-input';}

					$this->ROW_FILTER .= "<td>\n<input class=\"$CLASS\" maxlength=\"40\" name=\"$COLUMN\" value=\"$VALUE\" onkeypress=\"return nextfield(this,event, 'FILTER');\">\n</td>\n";

					unset($DATE);
				}
			}
		
			$this->ROW_FILTER .= "</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					if ($COLUMN == 'billID') $billID = $VALUE;
			
					if ($COLUMN == 'baseyear') 	{

						$year	= $VALUE;

					}	else	  {

						$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
					}
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"3\">\n"
							."<a class=\"list-link\" href=\"loader.php?cat=billdetails&amp;id=$billID&amp;year=$year\">$DETAILS</a>&nbsp;&nbsp;&nbsp;\n"
							."</td>\n";
				$this->TABLE_BODY .=	"</tr>\n";
			}

			$this->SQL->free();
		}

		/**
		 * Read posts
		 */

		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				if (isset($_SESSION['FILTERS'])) unset($_SESSION['FILTERS'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_POST['FILTER']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = 0;

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((isset($_POST[$COLUMN])) && (! is_empty($_POST[$COLUMN])))	{

						if ($this->FILTER_type[$COLUMN]=='date')	{

							if (! function_exists('date2search')) load_f('date2search');

							$this->FILTER_state[$COLUMN] = date2search($_POST[$COLUMN], $this->LANG->get('datesearchdaysign'), $this->LANG->get('datesearchmonthsign'), $this->LANG->get('datesearchyearsign'));

						}	else	  {

							$this->FILTER_state[$COLUMN] = $_POST[$COLUMN];
						}
					}
				}

				$_SESSION['FILTERS'] = $this->FILTER_state;

			}	else	 {

				if (isset($_SESSION['FILTERS'])) $this->FILTER_state = $_SESSION['FILTERS'];
			}
		}

		/**
		 * Create table
		 */

		public function create()	{

		$this->GETPOST();

			$this->TABLEHEADER();

			$this->TABLEFILTERS();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->ROW_FILTER $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);
		} 
	}
?>
