<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.0
	 */

	/**
	 * eBag payments loader into memory
	 */

	class PAYMENTloader	{
	
		var $PAYMENT = array();

		function __construct($apc=FALSE, $reload=FALSE)	{

			global $__SQL;
      
			if (! function_exists('apc_fetch')) $apc = FALSE;

			if ($apc)	{
			
				if ((! $reload) && (apc_exists('eBagPAYMENTS')))	{
				
					$this->PAYMENT = apc_fetch('eBagPAYMENTS');
				
					return;
				}
			}

			$this->PAYMENT['names']	 = array();
			
			$this->PAYMENT['values'] = array();

			# load & store all units

			$__SQL->query("SELECT * FROM ebag.payments ORDER BY `personID` ");

			if (! $__SQL->num_rows()) exit('Fatal error: payments not found ! Please contact your system administrator !');

			while ($row = $__SQL->RESULT->fetch_assoc()) 	{

				$this->PAYMENT['names'][$row['personID']]	=	$row['description'];
				$this->PAYMENT['values'][$row['personID']]	=	$row['expected_after_day'];
		
				if ($row['default']) $this->PAYMENT['default'] = $row['personID'];
			}
			
			$__SQL->free();

			if ($apc) apc_store('eBagPAYMENTS', (array)$this->PAYMENT, 0);
		}

		# returns payment names as associative array

		public function getnames()	{

			return (array)$this->PAYMENT['names'];
		}

		# returns payment values as associative array

		public function getvalues()	{

			return (array)$this->PAYMENT['values'];
		}

		# returns default payment 

		public function getdefault()	{

			return (string)$this->PAYMENT['default'];
		}
	}

?>
