<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag yearly realization
	 */

	class REALIZATION	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;
			
			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];

			$this->CURRENCY	=	$__CONF->get('payments', 'currency');

			$this->REALIZATION_TEXT	=	$__LANG->get("realizationtext", $_SESSION['year']);
		}

		public function create()	{

			$CURRENT_YEAR	=	$_SESSION['year'];

			$MAX		=	0;
			$REALIZATION	=	array();

			for ($i=1; $i<=12; $i++)	{ 
			
				$REALIZATION[$i] = 0;

				$this->SQL->query("	SELECT SUM(`sum`) 
							FROM $this->BASE.claims
							WHERE MONTH(`date_of_creation`)=$i AND YEAR(`date_of_creation`)=$CURRENT_YEAR	");
			
				if ($this->SQL->num_rows()) list($REALIZATION[$i]) = $this->SQL->RESULT->fetch_row();

				if ($MAX < $REALIZATION[$i]) $MAX = $REALIZATION[$i];
			}

			$this->TABLE	= '';

			$E_REALIZATION	= array_sum($REALIZATION);

			if (! $E_REALIZATION) return 'nothingisrealized';	

			$this->LABEL	= $this->LANG->get("realizationtext", $CURRENT_YEAR).' '.number_format($E_REALIZATION, 2, '.', '').' '.$this->CURRENCY;

			$this->TABLE	=  "<table class=\"realised-table\">\n";

			for ($i=1; $i<=12; $i++)	{
			
				if ($REALIZATION[$i] > 0) {$width = ceil(200*$REALIZATION[$i]/$MAX); $background="#426652";} else {$width = 1; $background="#B76A10";}

				$this->TABLE .=  '<tr><td class="realised-month">'.$this->LANG->get("monthname$i")."</td><td>\n"
						."<table class=\"realised-bar\" style=\"background : $background;\"><tr><td width=\"{$width}\">&nbsp;</td></tr></table>\n"
						."</td><td class=\"realised-sum\" style=\"color : $background;\">".round($REALIZATION[$i], 0)."</td><td style=\"color : $background;\">$this->CURRENCY</td></tr>\n";
			}

			$this->TABLE .= '</table>';

			return TRUE;
		}
	}
?>
