<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag list of selled articles to customer
	 */

	load_f('pagination');

	load_f('mb_wrap');

	class SELLEDARTICLES 	{

		var $SUMMARY		=	array();
		var $TABLE		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $COMMAND		=	'';
		var $SORT		=	'cadc8c8db42409733582cb3e2298ef87';
		var $contactID		=	'NULL';

		var $COLUMN_names	=	array(	'deliveryID', 'code', 'name', 'quantity', 'unit');

		var $COLUMN_names_AS	=	array();

		var $FILTER_type	=	array(	'deliveryID'=>'none', 'code'=>'box', 'name'=>'box', 'quantity'=>'numeric', 'unit'=>'box' );


		function __construct($INCREMENT)	{

			$this->INC	=	$INCREMENT;

			$this->BASE	=	$_SESSION['BASE'];

			global $__SQL, $__CONF, $__LANG, $__BOX;

			$this->SQL	=	&$__SQL;

			$this->BOX	=	&$__BOX;

			$this->LANG	=	&$__LANG;

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				$this->FILTER_state[$COLUMN]	=	FALSE;
				$this->COLUMN_names_AS[$COLUMN] = 	$this->LANG->get($COLUMN);
			}
		}

		/**
	 	 * Adds customer ID
		 */

		public function customerID($ID)	{

			$this->contactID	=	$ID;
		}

		/**
		 * Form command to sql
		 */

		private function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				$SEARCH	= $ORDERBY = '';

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((! isset($this->FILTER_state[$COLUMN])) or (! $this->FILTER_state[$COLUMN]))  continue;

					switch ($this->FILTER_type[$COLUMN])	{

						case('box')	:	$SEARCH	.= " AND `$COLUMN` REGEXP '".($this->SQL->s_escape($this->FILTER_state[$COLUMN], 'REGEXP'))."' ";

									break;

						case('numeric')	:	if ($this->FILTER_state[$COLUMN] == $this->SORT)	{

										$ORDERBY	= " ORDER BY `$COLUMN` ";
										break;
									}

									$SEARCH .= ' AND '.$COLUMN.html_entity_decode($this->FILTER_state[$COLUMN], ENT_COMPAT, 'UTF-8').' ';

									break;


						default		:	continue;
					}

				}
				
				if (! $ORDERBY) $ORDERBY = ' ORDER BY `deliveryID`, `personID` ';

				$this->COMMAND = "	SELECT SQL_CALC_FOUND_ROWS `deliveryID`, `code`, `name`, `quantity`, `unit`
							FROM $this->BASE.deliverys_data
							WHERE 	deliveryID IN (	SELECT `personID` 
										FROM $this->BASE.deliverys_header 
										WHERE `contactID`='$this->contactID' AND `deleted` IS NOT NULL)
 								AND `deleted` IS NOT NULL $SEARCH  $ORDERBY	";

				$_SESSION['COMMAND'] = $this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				$this->ROW_LABEL .= '<td height="30" class="column-names">'.mb_wrap($COLUMN, 7, '<br>')."</td>\n";
			}

			$this->ROW_LABEL	.=	'<td class="filters" rowspan="2">'."\n"
						 	.'<input class="button-list" type="submit" name="FILTER" value="'.$this->LANG->get('filter').'">'."\n"
							.'</td><td class="filters" rowspan="2">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n"
							.'</tr>'."\n";
		}

		/**
		 * Create tabe row with filters
		 */

		private function TABLEFILTERS()		{

			$this->ROW_FILTER	.=	'<tr class="list-filters">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				$VALUE	=	'';

				switch($this->FILTER_type[$COLUMN])	{

					case('none')	:	$this->ROW_FILTER .= '<td></td>'."\n";

								break;

					case('box')	:	$VALUE = $this->FILTER_state[$COLUMN];

								$this->ROW_FILTER .= "<td>\n<input class=\"filter-input\" maxlength=\"40\" name=\"$COLUMN\" value=\"$VALUE\" onkeypress=\"return nextfield(this,event, 'FILTER');\">\n</td>\n";

								break;

					case('numeric')	:	$this->ROW_FILTER .=  "<td>\n<select class=\"filter-input\" name=\"$COLUMN\">\n";

								if ($this->FILTER_state[$COLUMN]===FALSE)	{$selected='selected';}	else {$selected='';}

								$this->ROW_FILTER .= "<option $selected value=\"\">".$this->LANG->get('all')."</option>\n";

								if ($this->FILTER_state[$COLUMN] == $this->SORT)  {$selected='selected';} else {$selected='';}

								$this->ROW_FILTER .= "<option $selected value=\"$this->SORT\">".$this->LANG->get('sort')."</option>\n";

								$OPERATORS = array('!=0', '=0', '<0', '<10', '<20', '<30', '<50', '<100', '<500', '<1000');

								foreach ($OPERATORS as $OPERATOR)	{

									if ($this->FILTER_state[$COLUMN] == $OPERATOR)	{$selected = 'selected';} else {$selected = '';}

									$this->ROW_FILTER .= "<option $selected value=\"$OPERATOR\">$OPERATOR</option>\n";
								}

								$this->ROW_FILTER .=  "</select>\n</td>\n";

								break;
				}
			}
		
			$this->ROW_FILTER .= "</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 2;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					if ($COLUMN == 'deliveryID') $deliveryID = $VALUE;

					$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"3\">\n"
							."<a class=\"list-link\" href=\"loader.php?cat=deliverydetails&amp;id=$deliveryID\">$DETAILS</a>&nbsp;&nbsp;&nbsp;\n"
							."</td>\n"
							."</tr>\n";
			}

			$this->SQL->free();
		}

		/**
		 * Read posts
		 */

		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				if (isset($_SESSION['FILTERS'])) unset($_SESSION['FILTERS'], $_SESSION['COMMAND'], $_SESSION['LIMIT']);

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_POST['FILTER']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = 0;

				foreach ($this->COLUMN_names as $COLUMN)	{

					if ((isset($_POST[$COLUMN])) && (! is_empty($_POST[$COLUMN])))	$this->FILTER_state[$COLUMN] = $_POST[$COLUMN];
				}

				$_SESSION['FILTERS'] = $this->FILTER_state;

			}	else	 {

				if (isset($_SESSION['FILTERS'])) $this->FILTER_state = $_SESSION['FILTERS'];
			}
		}

		/**
		 * Create table
		 */

		public function create()	{

			$this->GETPOST();

			$this->TABLEHEADER();

			$this->TABLEFILTERS();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->ROW_FILTER $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);
		} 
	}
?>
