<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.0
	 */

	/**
	 * eBag units loader into apc
	 */

	class UNITloader	{
	
		var $UNIT = array();

		function __construct($apc=FALSE, $reload=FALSE)	{

			global $__SQL, $__CONF;
			
			$this->CONF = &$__CONF;

			if (! function_exists('apc_fetch')) $apc = FALSE;

			if ($apc)	{
			
				if ((! $reload) && (apc_exists('eBagUNITS'))) {
				
					$this->UNIT = apc_fetch('eBagUNITS');
				
					return;
				}
			}
			
			# load & store all units

			$__SQL->query("SELECT * FROM ebag.units");

			if (! $__SQL->num_rows()) exit('Fatal error: units not found ! Please contact your system administrator !');

			$this->UNIT['units']		=	array();
			
			$this->UNIT['int_types']	=	array();

			while ($row = $__SQL->RESULT->fetch_assoc()) 	{

				$this->UNIT['units'][] = $row['name'];

				if ($row['type']=='int') $this->UNIT['int_types'][] = $row['name'];

				# store default

				if ($row['default']) $this->UNIT['default'] = $row['name'];
			}

			$__SQL->free();
			
			if ($apc) apc_store('eBagUNITS', (array)$this->UNIT, 0);
		}

		/**
		 * Returns units
		 */

		public function getall()	{

			return (array)$this->UNIT['units'];
		}

		/**
		 * Returns default unit
 		 */

		public function getdefault()	{

			return (string)$this->UNIT['default'];
		}

		/**
		 * Returns true if gived unit type is integer
		 */

		public function is_int_unit($unit)	{
		
			if (! count($this->UNIT['int_types'])) return FALSE;
			
			if (in_array(htmlspecialchars($unit, $this->CONF->get('specialchars', 'flag'), 'UTF-8', FALSE), $this->UNIT['int_types'])) return TRUE;

			return FALSE;
		}
	}


?>
