<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag load backup
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');
	
	$view = new View('createbackup');
	
	$view->assign('SELF', backward());
	
	$view->assign('CREATE_BACKUP', $__LANG->get('create_backup'));
	$view->assign('OVERWRITE', $__LANG->get('overwrite_exist_data'));
	$view->assign('DUMP_STRUCTURE', $__LANG->get('dump_structure'));
	$view->assign('OTHER_BACKUP_PROGRESS', $__LANG->get('other_backup_process'));
	$view->assign('NO_BACKUP_DIR', $__LANG->get('no_backup_dir'));
	$view->assign('MAINTENANCE_IN_PROGRESS', $__LANG->get('maintenance_in_progress'));
	$view->assign('BACKUP_IN_PROGRESS', $__LANG->get('backup_in_progress'));
	$view->assign('BACKUP_COMPLETED', $__LANG->get('backup_completed'));
	
	if (! is_empty($__CONF->get('backup', 'directory')))	{
	
		$view->assign('BACKUP_DIR', $__LANG->get('backup_dir_found'));
		
		$start_disabled = '';
		 
	}	else	  {
	
		$view->assign('BACKUP_DIR', $__LANG->get('no_backup_dir_found'));
		
		$start_disabled = 'disabled';
	}
	
	$view->assign('DIRECTORY', $__CONF->get('backup', 'directory'));
	
	$view->assign('START', $__LANG->get('start'));
	$view->assign('DISABLED', $start_disabled);
	$view->assign('CANCEL', $__LANG->get('cancel'));
	$view->assign('BACKTO', 'loader.php?cat=section&amp;id=settings');
	
	$view->display();

?>
