<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag employee change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('employees');

	pagepermission('employees', 'w');

	if (isset($_GET['id']))		{

		$EMPLOYEE_ID = $_SESSION['ID'] = $_GET['id'];
		
		unset($_SESSION['_POST_ERR']);		

	}	else	  {

		$EMPLOYEE_ID = $_SESSION['ID'];
	}

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('employeechange');

		$__EMPLOYEE 	=	new EMPLOYEECHANGE();

		$RESULT		=	$__EMPLOYEE->change($EMPLOYEE_ID, $_POST);

		unset($__EMPLOYEE, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR'] = $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $_SESSION['FROM']);
		$view	->	display();
		exit;
	}

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		load_m('employeeread');

		$__EMPLOYEE	=	new EMPLOYEEREAD();

		$_POST		=	$__EMPLOYEE->read($EMPLOYEE_ID);

		unset($__EMPLOYEE, $__SQL);

		if (! $_POST)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('cannotread'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
	}

	$view	=	new View('employee');

	$view	->	assign('LABEL', $__LANG->get('employeechange', $EMPLOYEE_ID));
	$view	->	assign('EMPLOYEENAME', $__LANG->get('employeename'));
	$view	->	assign('IDENTITY_NUMBER', $__LANG->get('identitynumber'));
	$view	->	assign('PROFESSION', $__LANG->get('profession'));
	$view	->	assign('EDUCATION_DEGREE', $__LANG->get('educationdegree'));
	$view	->	assign('WORKPLACE', $__LANG->get('workplace'));
	$view	->	assign('DATE_OF_EMPLOYMENT', $__LANG->get('date_of_employment'));
	$view	->	assign('EMPLOYEES_ADDRESS', $__LANG->get('employeesaddress'));
	$view	->	assign('CITY', $__LANG->get('city'));
	$view	->	assign('ZIP', $__LANG->get('zip'));
	$view	->	assign('STREET', $__LANG->get('street'));
	$view	->	assign('TELEPHONE', $__LANG->get('telephone'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	$view	->	display();
?>
