<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag finished production phase change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('production');

	pagepermission('production', 'w');

	if (isset($_POST['submit']))	{

		load_c('SQL');

		$__SQL	= new SQL();

		load_m('finishedphasechange');

		$__PHASE	=	new FINISHEDPHASECHANGE();

		$RESULT		=	$__PHASE->change($_POST);
		
		unset($__PHASE, $__SQL);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward().'&amp;id='.$_POST['productionorderID']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('alertbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('NEW', $__LANG->get('new'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=production');
		$view	->	display();
		exit;
	}

	if ((isset($_POST['selected'])) or (isset($_GET['id'])))		{

		if (isset($_GET['id'])) $_POST['id'] = $_GET['id'];

		if ((! is_empty($_POST['id'])) && ((integer)$_POST['id'] > 0)) 	{

			load_c('SQL');

			$__SQL	= new SQL();

			load_m('finishedphasechangedefault');

			$__PHASE	=	new FINISHEDPHASECHANGEDEFAULT;

			$DATA		=	$__PHASE->read($_POST['id']);

			unset($__PHASE);

			if (! is_array($DATA)) $errtxt = $DATA;


			load_m('finisherread');
		
			$__FINISHERS	=	new FINISHERREAD();

			$FINISHERS	=	$__FINISHERS->read();

			unset($__FINISHERS);

			if (! $FINISHERS) $errtxt = 'nofinishers';

			if (isset($errtxt))	{

				$view	=	new View('errorbox');
				$view	->	assign('SELF', backward());
				$view	->	assign('ERROR', $__LANG->get('error'));
				$view	->	assign('ERRTXT', $__LANG->get($errtxt));
				$view	->	assign('BACK', $__LANG->get('back'));
				$view	->	display();
				exit;
			}	

			$view	=	new View('finishedphasechange');

			$view	->	assign('FINISHED_PHASE_CHANGE', $__LANG->get('finishedphasechange'));
			$view	->	assign('PERSONID', $__LANG->get('productionordernumber'));
			$view	->	assign('CODE', $__LANG->get('code'));
			$view	->	assign('ARTICALNAME', $__LANG->get('articalname'));
			$view	->	assign('QUANTITY', $__LANG->get('quantity'));
			$view	->	assign('CUSTOMER', $__LANG->get('customer'));
			$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
			$view	->	assign('FINISHED_PHASES', $__LANG->get('finishedphases'));
			$view	->	assign('FINISHER', $__LANG->get('finisher'));
			$view	->	assign('FINISHER_CHANGE', $__LANG->get('finisherchange'));
			$view	->	assign('PROCESS_TIME', $__LANG->get('process_time'));
			$view	->	assign('CHANGE_SELECTED_TO', $__LANG->get('changeselectedphase'));
			$view	->	assign('DELETE_SELECTED_PHASE', $__LANG->get('deleteselectedphase'));
			$view	->	assign('WRITE', $__LANG->get('write'));
			$view	->	assign('RESET', $__LANG->get('reset'));
			$view	->	assign('CANCEL', $__LANG->get('cancel'));
			$view	->	assign('BACKTO', backward());

			# form default data

			$__PHASES	=	new PHASEloader($__CONF->get('cache', 'use_apc_cache'));

			$PHASES		=	$__PHASES->getall();

			unset($__PHASES, $__SQL);

			# note: phase finished is unset because cannot be set here
			#	its set where whole production order is closed and
			#	after needs only to display

			unset($PHASES[2]);

			$view	->	assign('PHASES', $PHASES); unset($PHASES);
			$view	->	assign('FINISHERS', $FINISHERS); unset($FINISHERS);
			$view	->	assign('DATA', $DATA); unset($DATA);

			$view	->	display();

			exit;
		}
	}

	# display selector

	$view	=	new View('listselector');

	$view 	->	assign('SELF', backward());
	$view 	->	assign('SELECTLABEL', $__LANG->get('productionorderselect'));
	$view 	->	assign('SELECTEDID', $__LANG->get('productionorderbynumber'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=production');

	$view 	->	assign('OK', $__LANG->get('ok'));
	$view 	->	assign('RESET', $__LANG->get('reset'));
	$view 	->	assign('CANCEL', $__LANG->get('cancel'));

	$view	->	display();

?>
