<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * 	Configure installation enviroment
	 */
	 
	  # check for installed mark, prevent executing after install
	 
	  if (is_file('../conf/installed.conf'))	{
	 
		  include('../views/logout.php'); 
		  
		  exit;
	  }
	  
	  # try to load version number from configuration
	  
	  $conf = @parse_ini_file('../conf/eBag.ini', true);
	  
	  if (isset($conf['version']['version_number']))	{
	  
		  define ('VERSION_NUMBER', $conf['version']['version_number']);
		  
	  }	else	  {

		  define ('VERSION_NUMBER', '6.0.0');
	  }
	  
	  unset($conf);
	  
	  define ('BASEDIR', '../');
	  
	  # Defines var for includes re-check

	  define ('eBag', TRUE);
	  
	  # Sets mbstring functions
	
	  mb_internal_encoding('UTF-8');
	
	  mb_regex_encoding('UTF-8');

	  include(BASEDIR.'helpers/basichelpers.php');
	  
	  include(BASEDIR.'functions/url_encode.php');
	  
	  # sets error handler

	  class ERRHANDLER	{
	  
		  var $NOTICESTEP = FALSE;

		  function handler($errno, $errstr)	{

			  if (! error_reporting()) return; 
			  
			  if (in_array($errno, array(E_NOTICE, E_USER_NOTICE, E_STRICT, E_DEPRECATED, E_USER_DEPRECATED)) && $this->NOTICESTEP) return TRUE;
			  
			  return FALSE;
		  }

		  function start()	{

			  set_error_handler(array(&$this, 'handler'));
		  }
	  }

	  $__HANDLER = new ERRHANDLER();
	
	  $__HANDLER -> start();

	  # Turn off magic quotes runtime

	  if (get_magic_quotes_runtime()) set_magic_quotes_runtime(false);

	  # If magic quotes is enabled strip slashes from GETS and POSTS

	  if (get_magic_quotes_gpc()) {

		  if (isset($_POST) && $_POST)	{

			foreach($_POST as $key=>$val) $_POST[$key] = stripslashes($val);
		  }

		  if (isset($_GET) && $_GET)	{

			foreach($_GET as $key=>$val) $_GET[$key] = stripslashes($val);
		  }
	  }

?>