<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag inventory
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	if (isset($_POST['YES'])) $_GET['stock'] = $_POST['id'];
	
	check_year_for_write($_GET['stock']);

	pagepermission($_GET['stock'], 'w');

	if ($_GET['stock'] == 'feedstock') {$BACKTO = 'loader.php?cat=section&amp;id=feedstocks';} else {$BACKTO = 'loader.php?cat=section&amp;id='.$_GET['stock'];}

	if (	(! isset($_POST['YES'])) &&
		(! isset($_POST['action'])) &&
		(! isset($_GET['p_err']))	)	{

		# verify that realy want to make inventory

		$view	=	new View('verify');
		$view	->	assign('SELF', backward());
		$view	->	assign('QUESTION', $__LANG->get('createnewinventory'));
		$view	->	assign('YES', $__LANG->get('yes'));
		$view	->	assign('NO', $__LANG->get('no'));

		# store stock temporary as ID
		$view	->	assign('ID', $_GET['stock']);
		$view	->	assign('BACKTO', $BACKTO);

		$view	->	display();

		exit;
	}

	load_c('SQL');

	$__SQL	= new SQL();

	# create temp table if not exists

	load_m ('inventorytable');

	$__INVENTORY	=	new INVENTORYTABLE($_GET['stock']);

	$INV_TABLE	=	$__INVENTORY->gettable();

	$INV_TABLE_DATA	=	$__INVENTORY->readtable();

	unset($__INVENTORY);

	if ((isset($_POST['action'])) && ($_POST['action'] == 'destroy'))	{

		load_m('inventorydestroy');

		new INVENTORYDESTROY($INV_TABLE);
		
		unset($__SQL);

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('inventorydatadeleted'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $BACKTO);
		$view	->	display();
		exit;
	}

	if ((isset($_POST['action'])) && ($_POST['action'] == 'submit'))	{

		load_m('inventorymake');

		$__INVENTORY	=	new INVENTORYMAKE();

		$RESULT	=	$__INVENTORY ->	make($_POST, $INV_TABLE, $_GET['stock']);

		unset($__INVENTORY, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR'] = $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;stock='.$_GET['stock'].'&amp;p_err=true');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('inventorydatawrited'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', $BACKTO);
		$view	->	display();
		exit;
	}

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEESDATA	=	$__EMPLOYEES->read();

	unset($__EMPLOYES, $__SQL);

	if (! $EMPLOYEESDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $BACKTO);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# display the inventory form

	$view	=	new View('inventory');

	$view	->	assign('SELF', backward().'&amp;stock='.$_GET['stock']);
	$view	->	assign('INV_TABLE', $INV_TABLE);
	$view	->	assign('INV_TABLE_DATA', $INV_TABLE_DATA);
	$view	->	assign('STOCK', $_GET['stock']);
	$view	->	assign('INVENTORY', $__LANG->get('inventory'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('EMPLOYEE', $__LANG->get('employee'));
	$view	->	assign('EMPLOYEES', $EMPLOYEESDATA);
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('NAME', $__LANG->get('name'));
	$view	->	assign('STOCK_QUANTITY', $__LANG->get('stock_quantity'));
	$view	->	assign('COLUMNCHANGE', $__LANG->get('changereal'));
	$view	->	assign('DESTROY', $__LANG->get('destroy'));
	$view	->	assign('DESTROY_MSG', $__LANG->get('invdestroymsg'));
	$view	->	assign('SUBMIT_MSG', $__LANG->get('invsubmitmsg'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', $BACKTO);

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	 {

		$_POST['date_of_creation'] = date($__CONF->get('date', 'dateformat'));
	}

	$view	->	display();

?>

