<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag controller loader
	 */

	ob_start('ob_gzhandler');
	
	define('BASEDIR', '../');
	
	# Set time limit
	
	set_time_limit(300);

	# Load basic functions

	require(BASEDIR.'helpers/basichelpers.php');
	
	# Sets mbstring functions
	
	mb_internal_encoding('UTF-8');
	
	mb_regex_encoding('UTF-8');

	# Defines var for includes re-check

	define ('eBag', TRUE);

	# Reads the configuration

	load_c('INIload');

	$__CONF	= new INI_load(BASEDIR.'conf/eBag.ini');
	
	# Sets error handler

	load_c('Errorhandler');

	$__HANDLER = new ERRHANDLER();
	
	$__HANDLER -> start();

	# Sets session handler

	load_c('Sessionhandler');

	$__SESS	= new MysqlSession();
	
	$__SESS	-> set_session_handler();
	
	register_shutdown_function('session_write_close');
	
	# Session check (refresh permission because of expiration with self)

	session_start();

	# Loads language
	
	load_c('Language');
	
	$lang 	= strtolower($__CONF->get('language', 'lang'));

	$__LANG	= new Lang(BASEDIR."lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);
	
	if ((isset($_SESSION['year'])) && ($_SESSION['year']))	{

		$_SESSION['permission']=$_SESSION['permission'];

	}	else	  {

		if (isset($_GET['popup']) or isset($_POST['popup'])) {$_GET['nav'] = 'popupclose';} else {$_GET['nav'] = 'logout';}
	}

	# Check for a javascript enabled cookie

	if (isset($_COOKIE['eBagJavaEnabled']))	{

		setcookie('eBagJavaEnabled', '',time()-3600);

	}	else	  {

		if (isset($_GET['nav']) && ($_GET['nav'] != 'popupclose')) $_GET['nav'] = 'logout';
	}

	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# If magic quotes is enabled strip slashes from GETS and POSTS

	if (get_magic_quotes_gpc()) {

		if (isset($_POST) && $_POST)	{

		      foreach($_POST as $key=>$val) $_POST[$key] = stripslashes($val);
		}

		if (isset($_GET) && $_GET)	{

		      foreach($_GET as $key=>$val) $_GET[$key] = stripslashes($val);
		}
	}

	# Define essential constants

	if (isset($_SESSION['year'])) $_SESSION['BASE'] = 'ebagdata'.$_SESSION['year'];

	define('PAGEINCREMENT', $__CONF->get('display', 'increment'));

	define('EXCHANGERATE', $__CONF->get('payments', 'exchange_rate'));

	# unset temporary tables 

	unset(	$_SESSION['TEMPTABLE1'], $_SESSION['TEMPTABLE2'], $_SESSION['TEMPTABLE3'], 
		$_SESSION['DROPTABLE1'], $_SESSION['DROPTABLE2'], $_SESSION['DROPTABLE3'] );

	# Loaders
	
	load_c('BOX');

	$__BOX	= new BOX($__CONF->get('cache', 'use_apc_cache'), $__CONF->get('language', 'lang'));
	
	load_c('UNITloader');

	load_c('PAYMENTloader');

	load_c('DELIVERYloader');

	load_c('PHASEloader');

	# Load view class

	load_c('View');

	# Load the controller
	
	if (isset($_GET['nav']))	{
	
		$_GET['cat'] = $_GET['nav']; 
		
		unset($_GET['nav']);
		
		load_f('reset_session_vars');
	}

	if (! isset($_GET['cat']) or (! $_GET['cat'])) $_GET['cat']='home';

	include(BASEDIR.'controllers/'.$_GET['cat'].'.php');

?>
