<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag navigation
	 */

	ob_start('ob_gzhandler');
	
	define ('BASEDIR', '../');
	
	/**
	 * Check for cache
	 */
	 
	$cache_file = '../tmp/c_view_navigation.tmp';
	
	if (is_readable($cache_file)) {include($cache_file); exit;}
	
	/**
	 * Sets mbstring functions
	 */
	 
	mb_internal_encoding('UTF-8');
	
	mb_regex_encoding('UTF-8');

	/**
	 * Read the configuration
	 */

	require(BASEDIR.'classes/INIload.class.php');

	$__CONF	= new INI_load(BASEDIR.'conf/eBag.ini');
	
	/**
	 * Set errorhandler
	 */

	require(BASEDIR.'classes/Errorhandler.class.php');

	$__HANDLER = new ERRHANDLER();
	$__HANDLER -> start();

	/**
	 * Load navigation language (note: no apc)
	 */

	require(BASEDIR.'/classes/Language.nav.class.php');
	
	$lang = strtolower($__CONF->get('language', 'lang'));

	$__LANG = new LangNav(BASEDIR."lang/$lang/navigation.$lang");
	
	unset($lang);
	
	$LANG = (array)$__LANG->getLANG();
	$SECT = (array)$__LANG->getSECT();

	require(BASEDIR.'classes/View.class.php');

	$view =	new View('navigation');

	$view->assign('CATEGORY', $LANG);
	$view->assign('SECTIONS', $SECT);

	$content = $view->process();
	
	echo $content;
	
	@file_put_contents($cache_file, $content);

?>
