<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new service list
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	check_year_for_write('service_lists');

	pagepermission('service_lists', 'w');
	
	load_c('SQL');

	$__SQL = new SQL;

	if (isset($_POST['submit']))	{

		load_m('servicelistwrite');

		$__SERVICELIST	=	new SERVICELISTWRITE();

		unset($_POST['submit']);

		$RESULT		=	$__SERVICELIST->write($_POST);

		$NEWID 		=	$__SERVICELIST->getid();

		unset($__SQL, $__SERVICELIST);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=servicelistwrited&id=$NEWID");

		exit;
	}

	$__PAYMENTS	=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

	$PAYMENT_FORMS		=	$__PAYMENTS->getnames();
	$DEFAULT_PAYMENT	=	$__PAYMENTS->getdefault();

	unset($__PAYMENTS);

	$view	=	new View('servicelist');

	$view	->	assign('SELF', backward());
	$view	->	assign('SERVICELISTLABEL', $__LANG->get('newrevers'));
	$view	->	assign('CONTACTID', $__LANG->get('contactID'));
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('DATE_OF_DEADLINE', $__LANG->get('date_of_deadline'));
	$view	->	assign('PAYMENT_FORM', $__LANG->get('payment_form'));
	$view	->	assign('SESSIONDISCOUNT', $__LANG->get('session_discount'));
	$view	->	assign('SERVICEDISCOUNT', $__LANG->get('service_discount_in'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('COLUMNTAX', $__LANG->get('columnname_tax'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ANNOTATION', $__LANG->get('annotation'));
	$view	->	assign('PAYMENT', $__LANG->get('payment_form'));
	$view	->	assign('USED_SESSION_DISCOUNT', $__LANG->get('used_session_discount'));
	$view	->	assign('USED_SERVICE_DISCOUNT', $__LANG->get('used_service_discount'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('SUMMARY', $__LANG->get('summary'));
	$view	->	assign('PRICETXT', $__LANG->get('price'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=service_lists');
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	# form data

	$view	->	assign('PAYMENT_FORMS', $PAYMENT_FORMS);

	# Write back the post if error was

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);
	}

	# new 

	if ((! isset($_POST)) or (! count($_POST)))	{

		$_POST['use_session_discount']	=	'on';

		$_POST['use_service_discount']	=	'on';

		$_POST['session_discount'] 	= 	$_SESSION['discount'];

		$_POST['payment_form']		=	$DEFAULT_PAYMENT; unset($DEFAULT_PAYMENT);

		$_POST['date_of_creation']	=	date($__CONF->get('date', 'dateformat'));

		$_POST['date_of_deadline']	=	date($__CONF->get('date', 'dateformat'), strtotime($__CONF->get('delivery', 'default_deadline_for_service').' days'));

		$_POST['tax'] 			=	(integer)str_replace('%', '', $__CONF->get('tax', 'sales_tax'));

		$_POST['exchange_rate']		=	$__CONF->get('payments', 'exchange_rate');

		$_POST['currency']		=	$__CONF->get('payments', 'currency');

		$_POST['valuta']		=	$__CONF->get('payments', 'valuta');
	}
	
	unset($__SQL);

	$view	->	display();

?>
