<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new production order
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('production');

	pagepermission('production', 'w');

	load_c('SQL');

	$__SQL	= new SQL;

	if (isset($_POST['submit']))	{

		load_m('productionorderwrite');

		$__PRODUCTIONORDER	=	new PRODUCTIONORDERWRITE();

		unset($_POST['submit']);

		$RESULT		=	$__PRODUCTIONORDER->write($_POST);

		$NEWID 		=	$__PRODUCTIONORDER->getid();

		$ORDER2STOCK	=	$__PRODUCTIONORDER->ORDER_TO_STOCK;

		unset($__SQL, $__PRODUCTIONORDER);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;item='.$_GET['item'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		if ($ORDER2STOCK)	{

			header("location: loader.php?cat=order2stock_from_production&id=$NEWID");
			exit;
		}

		header("location: loader.php?cat=productionorderwrited&id=$NEWID");
		
		exit;

	}

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		list($orderID, $personID)	=	explode('-', $_GET['item']);

		load_m('productionorderdefault');

		$__PRODUCTIONORDER	=	new PRODUCTIONORDERDEFAULT;

		$_POST = $__PRODUCTIONORDER->read($orderID, $personID);

		if (! is_array($_POST))	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', 'loader.php?cat=new_production_order');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($_POST));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
	}

	$view	=	new View('productionorder');

	$view	->	assign('SELF', backward().'&amp;item='.$_GET['item']);
	$view	->	assign('PRODUCTION_ORDER_LABEL', $__LANG->get('newproductionorder'));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('ARTICALNAME', $__LANG->get('articalname'));
	$view	->	assign('CONNECTED_WITH_ORDER', $__LANG->get('connectedwithorder'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	$view	->	assign('CUSTOMER', $__LANG->get('customer'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('DATE_OF_DEADLINE', $__LANG->get('date_of_deadline'));
	$view	->	assign('TECHNOLOGY', $__LANG->get('technology'));
	$view	->	assign('DRAWING_NUMBER', $__LANG->get('drawingnumber'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=new_production_order');
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	unset($__SQL);
	
	$view	->	display();
?>
