<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag item related bonuses to employees
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('salarys');

	pagepermission('salarys', 'w');

	if (isset($_POST['selected']))	{
	
		load_c('SQL');

		$__SQL	= new SQL();

		$view	=	new View('phases_bonuses');

		$view	->	assign('SELF', backward());
		$view	->	assign('PHASE_RELATED_BONUS', $__LANG->get('phase_related_bonus'));
		
		$view	->	assign('SETTING_TYPE', $__LANG->get('setbonusto'));
		
		$view	->	assign('SET_TO_ALL_ITEMS', $__LANG->get('settoall'));
		$view	->	assign('SET_TO_SPECIFIC_ITEMS', $__LANG->get('settospecific'));

		$view	->	assign('NUMBER', $__LANG->get('personIDlong'));
		$view	->	assign('EMPLOYEE_NO', $__LANG->get('employee_no', $_POST['employeeID']));
		$view	->	assign('EMPLOYEE_NAME', $__LANG->get('lastname'));
		
		$view	->	assign('BONUS_PERCENT_PHASE', $__LANG->get('bonus_percent_phase'));
		$view	->	assign('BONUS_FIX_PHASE', $__LANG->get('bonus_fix_phase'));
		
		$view	->	assign('ITEM_CODE', $__LANG->get('code'));
		$view	->	assign('ITEM_NAME', $__LANG->get('name'));
		$view	->	assign('BONUS_TYPE', $__LANG->get('type'));
		$view	->	assign('BONUS_VALUE', $__LANG->get('value'));
		$view	->	assign('NOTICE', $__LANG->get('bonus_set_notice'));
		
		$__PHASES	=	new PHASEloader($__CONF->get('cache', 'use_apc_cache'));
		
		$PHASES		=	$__PHASES->getall();
		
		unset($__PHASES);

		# note: phase finished is unset 
		#	because it is used to close 
		
		unset($PHASES[2]);
		
		$view	->	assign('PHASES', $PHASES); unset($PHASES);
		$view	->	assign('PHASE', $__LANG->get('phase'));
		$view	->	assign('NOT_FOUND_MSG', $__LANG->get('notfound'));
		$view	->	assign('UNSET_MSG', $__LANG->get('bonusisunset'));
		$view	->	assign('SET_MSG', $__LANG->get('bonusisset'));
		$view	->	assign('SET', $__LANG->get('bonus_set'));
		$view	->	assign('INVALID_BONUS_MSG', $__LANG->get('invalidbonusvalue'));
		$view	->	assign('NOT_PRODUCT_MSG', $__LANG->get('isnotproduct'));
		$view	->	assign('RESET', $__LANG->get('reset'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', backward());
		
		$_POST['employee_id'] = $_POST['employeeID'];

		$view	->	display();

		exit;
	}

	# display employee select form
	
	load_c('SQL');

	$__SQL	= new SQL();

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEES	=	$__EMPLOYEES->read();

	unset($__EMPLOYEES);

	if (! $EMPLOYEES)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('employeeselect');

	$view	->	assign('SELECTEMPLOYEE', $__LANG->get('selectemployee'));
	$view	->	assign('NAME', $__LANG->get('employeename'));
	$view	->	assign('EMPLOYEES', $EMPLOYEES); unset($EMPLOYEES);
	$view	->	assign('OK', $__LANG->get('ok'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=salarys');
	
	unset($__SQL);

	$view	->	display();

?>
