<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag delete operating suplie enter
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	check_year_for_write('operating_suplies');

	pagepermission('operating_suplies', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	# verifyed delete it

	if (isset($_POST['YES']))	{

		load_m('directstockenterdelete');

		$__ENTER	=	new DIRECTSTOCKENTERDELETE('operating_suplies');

		$RESULT		= 	$__ENTER->delete($_POST['id']);

		unset($__ENTER, $__SQL);

		if ($RESULT)	{

			# deleted

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('enterdeleted', $_POST['id']));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', $_SESSION['FROM']);
			$view	->	display();
			exit;
		}

		# already deleted

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($RESULT));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# read enter data

	$ID	= $_GET['id'];

	load_m('directstockenterread');

	$__ENTER	=	new DIRECTSTOCKENTERREAD('operating_suplies');

	$ENTERDATA		=	$__ENTER->read($ID);
	
	unset($__ENTER);

	if (! $ENTERDATA) 	{

		# record was deleted in meantime

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('alreadydeleted'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	# read suplie data to show the quantity

	$UNIT	=	'';

	load_m('idsearch');

	$search	=	new IDSEARCH();

	$SUPLIEID	=	$search->bycode('ebagstock.operating_suplies', $ENTERDATA['code']);

	unset($search);

	if ($SUPLIEID)	{

		load_m('suplieread');

		$__SUPLIE	=	new SUPLIEREAD();
		$SUPLIEDATA	=	$__SUPLIE->read($SUPLIEID);

		$UNIT		=	$SUPLIEDATA['unit'];

		unset($__SUPLIE, $SUPLIEDATA);
	}

	unset($__SQL);
	
	# verify

	$view	=	new View('verify');
	$view	->	assign('SELF', backward());
	$view	->	assign('QUESTION', $__LANG->get('suretodelenter', $ID.' ('.$__LANG->get('code').': '.$ENTERDATA['code'].'=>'.$ENTERDATA['quantity'].' '.$UNIT.')'));
	unset($ENTERDATA);
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('ID', $ID);
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	display();

?>
