<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag settings add, change or delete unit
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');

	if (	(isset($_POST['addnew'])) or 
		(isset($_POST['change'])) or 
		(isset($_POST['delete'])) or
		(isset($_POST['default'])))	{

		$SUBMITTED	=	base64_encode(serialize($_POST));

		# note: store submitted data tamporary as id

		$view	=	new View('verify');
		$view	->	assign('SELF', backward());
		$view	->	assign('QUESTION', $__LANG->get('suretochangeunit'));
		$view	->	assign('YES', $__LANG->get('yes'));
		$view	->	assign('NO', $__LANG->get('no'));
		$view	->	assign('ID', $SUBMITTED);
		$view	->	assign('BACKTO', backward());
		$view	->	display();

		exit;
	}

	load_c('SQL');

	$__SQL	=  new SQL();
	
	if (isset($_POST['YES']))	{

		load_m('unitsettings');

		$__UNITS	=	new UNITSETTINGS();

		$SUBMITTED	=	unserialize(base64_decode($_POST['id']));

		if ((isset($SUBMITTED['int_type'])) && ($SUBMITTED['int_type'])) {$INT = TRUE;} else {$INT = FALSE;}

		if (isset($SUBMITTED['addnew']))	{

			$RESULT	= $__UNITS->addnew($SUBMITTED['newtext'], $INT);

		}	elseif (isset($SUBMITTED['change']))	{

			$RESULT = $__UNITS->change($SUBMITTED['selected'], $SUBMITTED['newtext'], $INT);

		}	elseif (isset($SUBMITTED['default']))	{

			$RESULT = $__UNITS->defaultunit($SUBMITTED['selected']);

		}	else	{

			$RESULT = $__UNITS->delete($SUBMITTED['selected']);
		}

		unset($__UNITS);

		if ($RESULT !== TRUE)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		# reload the units for all users
		
		# note: load($RELOAD = TRUE);

		$__UNITS	=	new UNITloader($__CONF->get('cache', 'use_apc_cache'), TRUE);

		unset($__UNITS);

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('settingssaved'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	$__UNITS	=	new UNITloader($__CONF->get('cache', 'use_apc_cache'));

	$UNITLIST	=	$__UNITS->getall();
	
	$INTTYPES	=	array();
	$UNITS		=	array();
	$i		=	1;

	foreach ($UNITLIST as $UNIT) {

		$UNITS[$i]	=	$UNIT;

		if ($__UNITS->is_int_unit($UNIT)) {$INTTYPES[$i] = 'i';} else {$INTTYPES[$i] = '';}

		$i++;
	}

	unset($UNITLIST, $__UNITS, $__SQL);

	$view	=	new View('units');

	$view	->	assign('SELF', backward());
	$view	->	assign('UNIT_SETTINGS', $__LANG->get('unitsettings'));
	$view	->	assign('UNIT', $__LANG->get('unit'));
	$view	->	assign('INTEGER_TYPE', $__LANG->get('integer_type'));
	$view	->	assign('NEW_NAME', $__LANG->get('newname'));
	$view	->	assign('SET_TO_DEFAULT', $__LANG->get('set_to_default'));
	$view	->	assign('ADDNEW', $__LANG->get('addnew'));
	$view	->	assign('CHANGE', $__LANG->get('change'));
	$view	->	assign('DELETE', $__LANG->get('delete'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');

	$view	->	assign('UNITS', $UNITS);
	$view	->	assign('INTTYPES', $INTTYPES); unset($UNITS, $INTTYPES);

	$view	->	display();

?>

