	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 4.0.1
	 */
	
	/**
	 * eBag copy selection from one select box to other && copy selected to hidden input
	 */

	function empty(box)	{

		var len,i;
		
		len = box.options.length - 1;
		
		if (len < 0) return;
		
		for (i=len; i>=0; i--) box.options.remove(i); 
	}


	function addoptions(box, newtexts, newvalues)	{

		var len,i;
		
		len = newtexts.length;

		for(i=0; i<len; i++)	{

			var optn	=	document.createElement("OPTION");
			optn.text 	=	newtexts[i];
			optn.value	=	newvalues[newtexts[i]];
			box.options.add(optn);
		}
	}

	function copy2box(from, to)	{

		var fbox	=	document.getElementById(from);
		var tbox	=	document.getElementById(to);

		var fvalues	=	[];
		var ftexts	=	[];
		var tvalues	=	[];
		var ttexts	=	[];
		var i;
		var tinc	=	0;
		var finc	=	0;

		var len		=	fbox.options.length;

		for(i=0; i<len; i++)	{

			if (fbox.options[i].selected)	{

				ttexts[tinc]		=	fbox.options[i].text;
				tvalues[ttexts[tinc]]	=	fbox.options[i].value;
				tinc++;

			}	else	{

				ftexts[finc]		=	fbox.options[i].text;
				fvalues[ftexts[finc]]	=	fbox.options[i].value;
				finc++;
			}
		}

		var len	= tbox.options.length;

		for(i=0; i<len; i++)	{

			ttexts[tinc]			=	tbox.options[i].text;
			tvalues[ttexts[tinc]]		=	tbox.options[i].value;
			tinc++;
		}

		ftexts.sort();

		empty(fbox);
		addoptions(fbox, ftexts, fvalues);

		ftexts = null;

		ttexts.sort();

		empty(tbox);
		addoptions(tbox, ttexts, tvalues);
	}

	/**
	 * Copyes all options from select selectbox to hidden input box
	 */

	function setselection()	{
	  
	  	var len, selectbox, selectedvalue, i;

		selectbox = document.getElementById('selected');

		len = selectbox.options.length;

		if (! len) return;

		for(i=0; i<len; i++)	{

			if (! selectedvalue)	{

				selectedvalue	=	selectbox.options[i].value;

			}	else	{

				selectedvalue	+=	',' + selectbox.options[i].value;
			}
		}

		document.forms[0].selecteditems.value = selectedvalue;
	}
