	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag show/hide quick search in parent frame
	 */
	
	function is_focusable(field)	{

		// returned value of the tagName property is always in UPPERCASE.
	  
		if ( (field != null) && ((field.tagName == 'BUTTON') || (field.tagName == 'INPUT') || (field.tagName == 'SELECT') || (field.tagName == 'TEXTAREA')) && (! field.disabled) ) return true;
		
		return false;
	}
	
	function frame_hide()	{
	  
		var focus_to = false;
	  
		// backto field present in artical & feedstock view
	  
		var backtofield = parent.document.getElementById("backto");

		if (is_focusable(backtofield)) focus_to = backtofield;
		
		// active field present in offers, orders ...
		
		activefield = parent.document.getElementById("active");

		if (activefield != null) {
			
			if (activefield.value.indexOf('rowid_') != -1)	{

				var elements	  = activefield.value.split('_');
				
				var codefield	  = parent.document.getElementById('code_' + elements[1]);

				var quantityfield = parent.document.getElementById('quantity_' + elements[1]);

				if ((is_focusable(codefield)) && (! codefield.value))	{

					focus_to = codefield;

				}	else	{

					if (is_focusable(quantityfield)) focus_to = quantityfield;
				}
			}
			
			if (! focus_to)	{
			  
				var active = parent.document.getElementById(activefield.value);

				if (is_focusable(active)) focus_to = active;
			}
			
			if (! focus_to)	{
			  
				var b_fields = ["contactID", "servicecode", "employeeID"];
				
				for (i=0; i<3; i++) {
				  
					var b_field = parent.document.getElementById(b_fields[i]);
				  
					if (is_focusable(b_field)) {focus_to = b_field; break;}
				}
			}
		}
		
		if (focus_to) {focus_to.focus();} else {parent.document.forms[0].focus();}
		
		var FRAME = parent.document.getElementById("quicksearch");

		FRAME.style.display	=	'none';
		FRAME.style.visibility 	=	'hidden';
	}

	// define escape function
	
	function escape__function() {frame_hide();}