<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag bill change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class BILLCHANGE	{

		var $reversIDs		=	FALSE;

		var $deliveryIDs	=	FALSE;

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->baseyear		=	$_SESSION['year'];
		}

		private function lock()	{

			$LOCK = "	LOCK TABLES	$this->BASE.bills_header WRITE, $this->BASE.bills_data WRITE, 
							$this->BASE.claims WRITE ";

			if ($this->reversIDs)	$LOCK .= ", $this->BASE.services_header WRITE, $this->BASE.services_data WRITE	";

			if ($this->deliveryIDs) $LOCK .= ", $this->BASE.deliverys_header WRITE,  $this->BASE.deliverys_data WRITE ";

			$this->SQL->query($LOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function change($DATA)	{

			$billID		=	$this->SQL->escape($DATA['billID']);
			
			$comment	= 	$this->SQL->n_escape($DATA['comment']);
			
			$annotation	=	$this->SQL->n_escape($DATA['annotation']);

			if ((isset($DATA['reversIDs'])) && (count($DATA['reversIDs'])))		$this->reversIDs	=	$DATA['reversIDs'];

			if ((isset($DATA['deliveryIDs'])) && (count($DATA['deliveryIDs'])))	$this->deliveryIDs	=	$DATA['deliveryIDs'];

			unset ($DATA);

			$this->SQL->transaction();
		
			$this->lock();

			$BILL_IS_DELETED	=	FALSE;

			# exist yet

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.bills_header
						WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentbill';
			}

			# delete reverses

			if ($this->reversIDs)	{

				foreach ($this->reversIDs as $reversID)		{

					$this->SQL->query("	DELETE FROM 
								$this->BASE.bills_data 
								WHERE 	`billID`='$billID' AND `dataID` IN (	SELECT `personID` 
														FROM $this->BASE.services_data 
														WHERE 	`reversID`='$reversID' AND `deleted` IS NOT NULL) 
								AND `datatype`='s'	");
								
					# update service list header

					$this->SQL->query("	UPDATE $this->BASE.services_header
								SET `billed`='0', `billID`=NULL 
								WHERE `personID`='$reversID' LIMIT 1	");

					# check the bill have more items

					$this->SQL->query("	SELECT `personID` 
								FROM $this->BASE.bills_data 
								WHERE `billID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

					if (! $this->SQL->num_rows())	{

						$this->SQL->query("	UPDATE $this->BASE.bills_header
									SET `deleted`=NULL, `delete_reason`='eBag'
									WHERE `personID`='$billID' LIMIT 1	");

						$BILL_IS_DELETED	=	TRUE;

						break;

					}	else	  {

						# correct the bill header connected with reverses

						$this->SQL->query("	SELECT `connected_with_reverses`
									FROM $this->BASE.bills_header
									WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

						$RESULT	=	$this->SQL->RESULT->fetch_row();

						if ($connected_with_reverses = $RESULT[0])	{

							$OLD	=	explode('-', $connected_with_reverses);

							$NEW	=	array();

							foreach ($OLD as $ELEMENT)	{

								if ((! $ELEMENT) or ($ELEMENT == $reversID)) continue;

								$NEW[] = $ELEMENT;
							}
							
							if (count($NEW))	{

								$connected_with_reverses = '\'-'.implode('-', $NEW).'-\'';

							}	else	  {

								$connected_with_reverses = "NULL";
							}

							$this->SQL->query("	UPDATE $this->BASE.bills_header
										SET `connected_with_reverses`=$connected_with_reverses
										WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");
						}
					}
				}
			}

			# delete deliverys

			if (($this->deliveryIDs) && (! $BILL_IS_DELETED))	{

				foreach ($this->deliveryIDs as $deliveryID)	{

					# delete bills data

					$this->SQL->query("	DELETE FROM $this->BASE.bills_data 
								WHERE 	`billID`='$billID' AND `dataID` IN (	SELECT `personID` 
														FROM $this->BASE.deliverys_data 
														WHERE `deliveryID`='$deliveryID' AND `deleted` IS NOT NULL) 
								AND `datatype`='d'	");
								
					# update delivery list header

					$this->SQL->query("	UPDATE $this->BASE.deliverys_header
								SET `billed`='0', `billID`=NULL 
								WHERE `personID`='$deliveryID' LIMIT 1	");

					# check the bill have more items

					$this->SQL->query("	SELECT `personID` 
								FROM $this->BASE.bills_data 
								WHERE `billID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

					if (! $this->SQL->num_rows())	{

						$this->SQL->query("	UPDATE $this->BASE.bills_header
									SET `deleted`=NULL, `delete_reason`='eBag'
									WHERE `personID`='$billID' LIMIT 1	");

						$BILL_IS_DELETED	=	TRUE;

						break;

					}	else	  {

						# correct the bill header connected with deliverys

						$this->SQL->query("	SELECT `connected_with_deliverys`
									FROM $this->BASE.bills_header
									WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

						$RESULT	=	$this->SQL->RESULT->fetch_row();

						if ($connected_with_deliverys = $RESULT[0])	{

							$OLD	=	explode('-', $connected_with_deliverys);

							$NEW	=	array();

							foreach ($OLD as $ELEMENT)	{

								if ((! $ELEMENT) or ($ELEMENT == $deliveryID)) continue;

								$NEW[] = $ELEMENT;
							}
							
							if (count($NEW))	{

								$connected_with_deliverys = '\'-'.implode('-', $NEW).'-\'';

							}	else	  {

								$connected_with_deliverys = "NULL";
							}

							$this->SQL->query("	UPDATE $this->BASE.bills_header
										SET `connected_with_deliverys`=$connected_with_deliverys
										WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");
						}
					}
				}
			}

			if ($BILL_IS_DELETED)	{

				# delete from claims

				$this->SQL->query("	DELETE FROM $this->BASE.claims
							WHERE `billID`='$billID' LIMIT 1	");

			}	else	  {

				# update comment and annotation in header
			
				$this->SQL->query("	UPDATE $this->BASE.bills_header
							SET `comment`=$comment, `annotation`=$annotation
							WHERE `personID`='$billID' LIMIT 1	");

				# update claims

				$this->SQL->query("	SELECT SUM(price * quantity * ((100 + tax)/100))
							FROM $this->BASE.bills_data WHERE `billID`='$billID' AND `deleted` IS NOT NULL	");

				$RESULT		=	$this->SQL->RESULT->fetch_row();

				$PRICE_SUM_WITH_TAX	=	$RESULT[0];

				$this->SQL->query("	SELECT `contactID`, `contactname`, `city`, `date_of_creation`, `payment_deadline`
							FROM $this->BASE.bills_header
							WHERE `personID`='$billID' AND `deleted` IS NOT NULL LIMIT 1	");

				$RESULT		=	$this->SQL->RESULT->fetch_assoc();

				extract($RESULT);

				# delete old record

				$this->SQL->query("	DELETE FROM $this->BASE.claims 
							WHERE `billID`='$billID' AND `baseyear`='$this->baseyear' LIMIT 1	");

				# insert new one

				$this->SQL->query("	INSERT INTO $this->BASE.claims
							VALUES 
							(NULL, '$billID', '$date_of_creation', '$payment_deadline', '$contactID', '$contactname',
							'$city', '$PRICE_SUM_WITH_TAX', '$this->baseyear', '0')	");
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
