<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag bill details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class BILLDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL		=	&$__SQL;

			$this->FORMAT		=	$__CONF->get('date', 'sql_format');
			
			$this->APC		=	$__CONF->get('cache', 'use_apc_cache');

			$this->BASE		=	$_SESSION['BASE'];

			$this->SERVICEMARK	=	strtoupper(substr($__LANG->get('revers'), 0,1));

			$this->DELIVERYMARK	=	strtoupper(substr($__LANG->get('delivery'), 0,1));
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{
	
			$this->SQL->query("LOCK TABLES	$this->BASE.bills_header WRITE, $this->BASE.bills_data WRITE,
							$this->BASE.services_data WRITE, $this->BASE.deliverys_data WRITE	");
		}
	
		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function createlist($STRING)	{

			if (! $STRING) return '';

			$LIST	=	explode('-', $STRING);

			unset($LIST[count($LIST)-1], $LIST[0]);

			return implode(',', $LIST);
		}

		public function read($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$DATA	=	FALSE;

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;
			
			# read payments
			
			$__PAYMENTS	=	new PAYMENTloader($this->APC);

			$PAYMENT_FORMS	=	$__PAYMENTS->getnames();
			
			unset($__PAYMENTS);

			# read
			
			$this->lock();
			
			# read header

			$this->SQL->query("	SELECT 	`contactname`, `country`, `city`, `zip`, `street`, `payment_form`, 
							`connected_with_deliverys`, `connected_with_reverses`, `currency`, 
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(`payment_deadline`, '$this->FORMAT') AS `payment_deadline`,
							`comment`, `annotation`
		 	 			FROM $this->BASE.bills_header WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				$DATA['connected_with_reverses']	=	$this->createlist($DATA['connected_with_reverses']);

				$DATA['connected_with_deliverys']	=	$this->createlist($DATA['connected_with_deliverys']);

				$DATA['bill_year']			=	str_replace('ebagdata', '' , $this->BASE);
				
				if (isset($PAYMENT_FORMS[$DATA['payment_form']])) $DATA['payment_form'] = $PAYMENT_FORMS[$DATA['payment_form']];

				unset($PAYMENT_FORMS);

				$this->SQL->query("	SELECT `code`, `name`, `quantity`, `unit`, `price`, `tax`, `dataID`, `datatype` 
							FROM $this->BASE.bills_data
							WHERE `billID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;
					
					# Initialize vars

					$DATA['price_sum'] = $DATA['price_tax'] = $DATA['price_sum_tax'] = 0;
					
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = $DATA['sum'] = $DATA['sum_tax'] = $DATA['pointID'] = array();

					while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())		{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
						$DATA['price'][]	=	$RESULT['price'];
						$DATA['tax'][]		=	$RESULT['tax'];
						$dataID			=	$RESULT['dataID'];
						$datatype		=	$RESULT['datatype'];

						# calculate sums

						$SUM			=	$RESULT['price']*$RESULT['quantity'];

						$TAX			=	$SUM * $RESULT['tax']/100;
						
						$SUM_TAX		=	$SUM + $TAX;
						
						$DATA['sum'][]		=	number_format($SUM, 2, '.', '');
						
						$DATA['sum_tax'][]	=	number_format($SUM_TAX, 2, '.', '');

						$DATA['price_sum']	+=	$SUM;

						$DATA['price_tax']	+=	$TAX;
						
						$DATA['price_sum_tax']	+=	$SUM_TAX;

						# read linenumber

						$MARK =	$ID_STR	= $LINE = '';

						if ($datatype == 's')	{

							$TABLE		=	'services_data';
							$SEARCHID	=	'reversID';
							$MARK		=	$this->SERVICEMARK;

						}	else	  {

							$TABLE		=	'deliverys_data';
							$SEARCHID	=	'deliveryID';
							$MARK		=	$this->DELIVERYMARK;
						}

						$this->SQL->query("	SELECT `$SEARCHID`
									FROM $this->BASE.$TABLE
									WHERE `personID`='$dataID' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$RESULT1	=	$this->SQL->RESULT->fetch_row();

							$ID_STR		=	$RESULT1[0];

							$this->SQL->query("	SELECT `personID`
										FROM $this->BASE.$TABLE
										WHERE `$SEARCHID`='$ID_STR'
										AND `deleted` IS NOT NULL ORDER BY `personID`	");

							$LINE	=	1;

							if ($this->SQL->num_rows())	{

								while ($RESULT1 = $this->SQL->RESULT->fetch_row())	{

									if ($dataID == $RESULT1[0])	{break;} else {$LINE++;}
								}
							}
						}

						$DATA['pointID'][]	=	"$MARK$ID_STR->$LINE";
					}

					$DATA['price_sum']	=	number_format($DATA['price_sum'], 2, '.', '');
					$DATA['price_tax']	=	number_format($DATA['price_tax'], 2, '.', '');
					$DATA['price_sum_tax']	=	number_format($DATA['price_sum_tax'], 2, '.', '');

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}
?>
