<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag employee change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('date2sql');
	
	load_f('is_longer');

	class EMPLOYEECHANGE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->CONF	=	&$__CONF;

			$this->BASE	=	$_SESSION['BASE'];

		}

		private function lock()	{

			$this->SQL->query(" LOCK TABLES $this->BASE.employees WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function prepare($DATA)	{

			if 	((is_empty($DATA['employeename'])) or
				(is_longer($DATA['employeename'], 30)) or
				(is_empty($DATA['identity_number'])) or
				(is_empty($DATA['profession'])) or
				(is_empty($DATA['workplace'])) or
				(is_empty($DATA['date_of_employment']))) return FALSE;

			foreach ($DATA as $key=>$val)	{

				if ($key == 'date_of_employment')	{

					$DATA[$key]	=	date2sql($val, $this->CONF->get('date', 'dateformat'));

					if (! $DATA[$key]) {$error = TRUE; break;}
			
					continue;
				}

				$DATA[$key]	=	$this->SQL->n_escape($val);
			}

			if (isset($error)) $DATA = FALSE;

			return $DATA;
		}


		public function change($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			extract($DATA); unset($DATA);

			$this->lock();
			
			# check the new name maybe exists

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.employees 
						WHERE `employeename`=$employeename AND `personID`!='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'employeeexists';				
			}

			# check the record exist

			$this->SQL->query("	SELECT `employeename` 
						FROM $this->BASE.employees
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'unexistentemployee';
			}

			$this->SQL->query("	UPDATE $this->BASE.employees
						SET	`employeename`=$employeename, `identity_number`=$identity_number, `profession`=$profession,
							`workplace`=$workplace, `education_degree`=$education_degree, `date_of_employment`='$date_of_employment',
							`city`=$city, `zip`=$zip, `street`=$street, `telephone`=$telephone
						WHERE	`personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
			return TRUE;
		}
	}

?>
