<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag feedstock write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('addtax');

	load_f('is_real_positive');
	
	load_f('is_longer');

	class FEEDSTOCKWRITE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;
			
			$this->BASE		=	$_SESSION['BASE'];
			
			$this->STOCKBASE	=	'ebagstock';
		}

		private function prepare($DATA)	 {

			# Check user input

			if ((is_empty($DATA['feedstockname'])) or 
			    (is_empty($DATA['code'])) or
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['unit'])) or
			    (is_empty($DATA['dimensions']))) return FALSE;

			if (((! is_empty($DATA['calculation_price'])) && ((! is_numeric($DATA['calculation_price'])) or ($DATA['calculation_price'] < 0))) or 
			    ((! is_empty($DATA['purchase_price'])) && ((! is_numeric($DATA['purchase_price'])) or ($DATA['purchase_price'] < 0)))) return FALSE;

			# Change empty prices to zero
			
			if (is_empty($DATA['purchase_price'])) 		$DATA['purchase_price'] = 0;
			if (is_empty($DATA['calculation_price'])) 	$DATA['calculation_price'] = 0;

			# Escape the data

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;			
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.addressbook WRITE, 
							ebagstock.feedstock WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function write($DATA)	{

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			$this->lock();

			extract($DATA); unset($DATA);

			# check supplier exists

			$this->SQL->query("	SELECT `city` 
						FROM $this->BASE.addressbook 
						WHERE `personID`=$supplierID AND `contactname`=$supplier AND `deleted` is NOT NULL LIMIT 1");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return 'suppliernotmatch';
			}

			# check feedstock exists

			$this->SQL->query("	SELECT `personID` 
						FROM $this->STOCKBASE.feedstock 
						WHERE `code`=$code AND `deleted` is NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();
				return 'feedstockexists';
			}

			$COMMAND	=	"INSERT INTO $this->STOCKBASE.feedstock VALUES 
						(NULL, $code, $feedstockname, $dimensions, $unit, '0', '0', '0', '0', $purchase_price, 
						$calculation_price, $origin, $supplier, $supplierID, $comment, '0')";

			$this->SQL->query($COMMAND);

			$this->unlock();

			return TRUE;
		}

		public function copy($DATA)	{

			$RESULT	= $this->write($DATA);

			return $RESULT;
		}
	}

?>
