<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag finished phase change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('is_int_positive');

	class FINISHEDPHASECHANGE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];
			
			$__PHASES		= 	new PHASEloader($__CONF->get('cache', 'use_apc_cache'));

			$this->DEFAULT_PHASE	=	$__PHASES->getdefault();

			unset($__PHASES);
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.production_orders_header WRITE, 
							$this->BASE.production_orders_phases WRITE,
							$this->BASE.addressbook WRITE, 
							$this->BASE.employees WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function finisherexist($FINISHER)	{

			list($TYPE, $FINISHERID)	=	explode('_', $FINISHER);

			if ($TYPE == 'employee')	{

				$COMMAND = "SELECT `employeename` FROM $this->BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

			}	else	   {

				$COMMAND = "SELECT `contactname` FROM $this->BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
			}

			$this->SQL->query($COMMAND);

			if (! $this->SQL->num_rows()) return FALSE;

			return TRUE;
		}

		private function updateheader($productionorderID)	{

			$this->SQL->query("	SELECT MAX(`personID`) 
						FROM $this->BASE.production_orders_phases
						WHERE `productionorderID`='$productionorderID'	");

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			$lastphaseID	=	$RESULT[0];

			$this->SQL->query("	UPDATE $this->BASE.production_orders_header
						SET `production_phase`=(	SELECT `production_phase` 
										FROM $this->BASE.production_orders_phases
										WHERE `personID`='$lastphaseID' LIMIT 1	)
						WHERE `personID`='$productionorderID' LIMIT 1	");
		}

		public function change($DATA)	{

			if ((! isset($DATA['finished_phase'])) or (! $DATA['finished_phase'])) return 'nothingisselected';

			$phaseID		=	$DATA['finished_phase'];

			$productionorderID	=	$DATA['productionorderID'];

			$newfinisher	=	$process_time	=	$new_phase	=	FALSE;

			if (isset($DATA['newfinisher']))	$newfinisher	=	$DATA['newfinisher'];

			if (isset($DATA['process_time']))	$process_time	=	$DATA['process_time'];

			if (isset($DATA['new_phase']))		$new_phase	=	$DATA['new_phase'];

			# start transaction

			$this->SQL->transaction();
		
			$this->lock();

			# check the row exists yet & read the phase on it

			$this->SQL->query("	SELECT `production_phase` 
						FROM $this->BASE.production_orders_phases
						WHERE `personID`='$phaseID' LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentphase';
			}

			$RESULT		=	$this->SQL->RESULT->fetch_row();

			$selectedphase	=	$RESULT[0];

			# check the production order exists
			# the finished phase can be changed if the production order is closed

			$this->SQL->query("	SELECT `code` 
						FROM $this->BASE.production_orders_header
						WHERE	`personID`='$productionorderID'	AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentproductionorder';
			}

			if ((isset($DATA['delete_selected'])) && ($DATA['delete_selected']))	{

				# delete selected phase

				if ($selectedphase != 1)	{

					# security check read number of rows
					
					$this->SQL->query("	SELECT `personID`
								FROM $this->BASE.production_orders_phases 
								WHERE `productionorderID`='$productionorderID'	");
								
					if ($this->SQL->num_rows() <= 1) $errtxt = 'cannotchangefirstphase';
					
				}	else	  {
				
					$errtxt = 'cannotchangefirstphase';
				}

				if (isset($errtxt))	{

					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}

				# delete the row

				$this->SQL->query("	DELETE FROM $this->BASE.production_orders_phases
							WHERE `personID`='$phaseID' LIMIT 1	");

				$this->updateheader($productionorderID);

				$this->SQL->commit();

				$this->unlock();

				return TRUE;	
			}

		
			if ($newfinisher)	{

				if (! $this->finisherexist($newfinisher))	{

					$this->SQL->rollback();

					$this->unlock();

					return 'finisherdeleted	';
				}
	
				# update

				$finisher	=	$this->SQL->n_escape($newfinisher);

				$this->SQL->query("	UPDATE $this->BASE.production_orders_phases 
							SET `finisher`=$finisher
				  			WHERE `personID`='$phaseID' LIMIT 1	");
			}

			if ($process_time)	{

				if (! is_int_positive($process_time))	{

					$this->SQL->rollback();

					$this->unlock();

					return 'usererror';
				}

				# update

				$this->SQL->query("	UPDATE $this->BASE.production_orders_phases 
							SET `process_time`='$process_time'
				  			WHERE `personID`='$phaseID' LIMIT 1	");
			}

			if ($new_phase)	{

				if ($selectedphase == 1)  $errtxt = 'cannotchangefirstphase';
				
				if ($new_phase == $this->DEFAULT_PHASE) $errtxt = 'defaultphaseononce';
				
				if (isset($errtxt))	{
				
					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}

				$new_phase	=	$this->SQL->n_escape($new_phase);

				$this->SQL->query("	UPDATE $this->BASE.production_orders_phases
							SET `production_phase`=$new_phase
				  			WHERE `personID`='$phaseID' LIMIT 1	");

				$this->updateheader($productionorderID);
			}

			$this->SQL->commit();

			$this->unlock();

			return TRUE;	
		}
	}
?>
