<?php

	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 4.0.0
	 */

	/**
	 * eBag script to migrate version 3.0.7 to 4.0.0
	 */

	 set_time_limit(0);
	 
	 error_reporting(E_ALL);

	 if (isset($_POST['proceed']))	{
	 
		include('../helpers/basichelpers.php');
		include('../classes/INIload.class.php');
		include('../classes/SQL.class.php');
		
		$__CONF = new INI_load('../conf/eBag.ini');
			  
		$__SQL =  new SQL();
		
		class Migrate3to4	{
		
			function __construct()	{
			  
				global $__CONF, $__SQL;
			  
				$this->CONF = &$__CONF;
			  
				$this->SQL =  &$__SQL;
				  
				$this->yearsread();
			}
			  
			private function yearsread()	{

				$this->SQL->query("	SELECT `year`, `closed` 
							FROM ebag.years 
							ORDER BY `year`	");
							
				$this->YEARS = array();

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->YEARS[$RESULT[0]] = $RESULT[1];

			}
			  
			private function column_exists($table, $column)	{
			  
				$exists = false;
				
				$this->SQL->query("SHOW COLUMNS FROM $table");
				
				while ($RESULT = $this->SQL->RESULT->fetch_assoc()) {
				
					if ($column == $RESULT['Field'])	{
					
						$exists = TRUE;
						
						break;
					}
				}
				
				return $exists;
			}       
			  
			function proceed()	{
			  
				# 1 add sick_leave_100 into working_hours
				
				foreach ($this->YEARS as $year=>$closed)	{
				
					$table = "ebagdata$year.working_hours";
				
					if (! $this->column_exists($table, 'sick_leave_100'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `sick_leave_100` varchar(2) AFTER `sick_leave` ");
						
						$this->SQL->query("	UPDATE $table 
									SET `sick_leave_100`='0' 
									WHERE `personID`!=0 ");
					}
				}
				
				# 2. add E_sick_leave_100 into salarys
				
				foreach ($this->YEARS as $year=>$closed)	{
				
					$table = "ebagdata$year.salarys";
				      
					if (! $this->column_exists($table, 'E_sick_leave_100'))	{
				
						$this->SQL->query("	ALTER TABLE $table
									ADD `E_sick_leave_100` decimal(10,2) NOT NULL AFTER `E_sick_leave` ");
						
						$this->SQL->query("	UPDATE $table
									SET `E_sick_leave_100`='0' 
									WHERE `personID`!=0 ");
					}
				}
			  }
		}
		
		$migrate = new Migrate3to4();
		$migrate -> proceed();
		
		$MESSAGE = 'Migration completed. Please delete browser cache and restart the server before you login !';
		
	}	else	{
	
		$MESSAGE = '<form action="'.$_SERVER['PHP_SELF'].'" name="migration" method="post" target="_self">eBag migration script from 3.0.7 to 4.0.0<br><br><input value="Proceed" type="submit" name="proceed"></form>';
	}
	 
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head> 
		<meta HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8"/>
 		<meta name="robots" content="noindex,nofollow" />
		<title>eBag</title>
	</head>

	<body bgcolor="#FFFFFF">

			<table width=100% height="200" cellpadding="0" cellspacing="0">
				<tr><td align="center" valign="center">
					<font face="verdana, arial, helvetica" size="2"> <?php echo $MESSAGE; ?></font>
				</td></tr>
			</table>
	</body>
</html>