<?php

	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */
	 
	/**
	 * eBag script to migrate version 4.0.1 to 5.0.0
	 */

	 set_time_limit(0);
	 
	 error_reporting(E_ALL);

	 if (isset($_POST['proceed']))	{
	 
		include('../helpers/basichelpers.php');
		include('../classes/INIload.class.php');
		include('../classes/SQL.class.php');
		
		$__CONF = new INI_load('../conf/eBag.ini');
			  
		$__SQL =  new SQL();
		
		class Migrate4to5	{
		
			function __construct()	{
			  
				global $__CONF, $__SQL;
			  
				$this->CONF = &$__CONF;
			  
				$this->SQL =  &$__SQL;
				  
				$this->yearsread();
			}
			  
			private function yearsread()	{

				$this->SQL->query("	SELECT `year`, `closed` 
							FROM ebag.years 
							ORDER BY `year`	");
							
				$this->YEARS = array();

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->YEARS[$RESULT[0]] = $RESULT[1];

			}
			  
			private function column_exists($table, $column)	{
			  
				$exists = false;
				
				$this->SQL->query("SHOW COLUMNS FROM $table");
				
				while ($RESULT = $this->SQL->RESULT->fetch_assoc()) {
				
					if ($column == $RESULT['Field'])	{
					
						$exists = TRUE;
						
						break;
					}
				}
				
				return $exists;
			}       
			  
			function proceed()	{
			  
				# add type column into production_orders_data
				# and set all records as feedstock 'f'
				
				foreach ($this->YEARS as $year=>$closed)	{
				
					$table = "ebagdata$year.production_orders_data";
				
					if (! $this->column_exists($table, 'type'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `type` varchar(1) NOT NULL AFTER `quantity` ");
						
						$this->SQL->query("	UPDATE $table 
									SET `type`='f' 
									WHERE `personID`!=0 ");
					}
				}
				
				# add quantity_as_part column to finished_goods_stock
				# and set all records to 0
				
				foreach ($this->YEARS as $year=>$closed)	{
				
					if ($closed) {$table = "ebagdata$year.finished_goods_stock";} else {$table = "ebagstock.finished_goods_stock";}
				      
					if (! $this->column_exists($table, 'quantity_as_part'))	{
				
						$this->SQL->query("	ALTER TABLE $table
									ADD `quantity_as_part` decimal(10,2) AFTER `quantity_in_production` ");
						
						$this->SQL->query("	UPDATE $table
									SET `quantity_as_part`='0' 
									WHERE `personID`!=0 ");
					}
				}
			  }
		}
		
		$migrate = new Migrate4to5();
		$migrate -> proceed();
		
		$MESSAGE = 'Migration completed. Please restart the server before the first login !';
		
	}	else	{
	
		$MESSAGE = '<form action="'.$_SERVER['PHP_SELF'].'" name="migration" method="post" target="_self">eBag migration script from 4.0.1 to 5.0.0<br><br><input value="Proceed" type="submit" name="proceed"></form>';
	}
	 
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head> 
		<meta HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8"/>
 		<meta name="robots" content="noindex,nofollow" />
		<title>eBag</title>
	</head>

	<body bgcolor="#FFFFFF">

			<table width=100% height="200" cellpadding="0" cellspacing="0">
				<tr><td align="center" valign="center">
					<font face="verdana, arial, helvetica" size="2"> <?php echo $MESSAGE; ?></font>
				</td></tr>
			</table>
	</body>
</html>