<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag orders read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDERREAD	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;
			$this->LANG	=	&$__LANG;
			$this->CONF	=	&$__CONF;
			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.orders_header WRITE, 
							$this->BASE.orders_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$DATA	=	'unexistentorder';

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return $DATA;

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			$FORMAT	=	$this->CONF->get('date', 'sql_format');

			$this->SQL->query("	SELECT 	`contactID`, `contactname`, DATE_FORMAT(`date_of_creation`, '$FORMAT') AS `date_of_creation`, 
							`date_of_creation` AS `date_of_creation_sql`, `date_of_deadline`, `article_discount`, `use_session_discount`, 
							`use_article_discount`, `currency`, `valuta`, `exchange_rate`, `session_discount`, `comment`, `annotation`, `delivery_form`, 
							`payment_form`
						FROM $this->BASE.orders_header WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");


			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				# calculate deadline days back to show in form

				$date_of_creation	=	explode('-', $DATA['date_of_creation_sql']);
				$time_of_creation	=	mktime( 0, 0, 0, $date_of_creation[1], $date_of_creation[2], $date_of_creation[0]);
				$date_of_deadline	=	explode('-', $DATA['date_of_deadline']);
				$time_of_deadline	=	mktime( 0, 0, 0, $date_of_deadline[1], $date_of_deadline[2], $date_of_deadline[0]);

				$DATA['deadline_days']	=	round(($time_of_deadline-$time_of_creation)/60/60/24);

				if ($DATA['deadline_days'] <= 0) $DATA['deadline_days'] = $this->CONF->get('delivery', 'default_deadline_for_shipment');

				unset($DATA['date_of_creation_sql']);
				
				$DATA['order_year']	=	str_replace('ebagdata', '' , $this->BASE);

				# read data

				$this->SQL->query("	SELECT	`code`, `articalname`, `quantity`, `unit`, `price`, `tax`, `date_of_delivery`, `productionorderID` 
							FROM $this->BASE.orders_data
							WHERE `orderID`='$ID' AND `deleted` IS NOT NULL	ORDER BY `personID`	");

				if ($this->SQL->num_rows())	{
				
					# Initialize vars
				
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = $DATA['locked'] = array();

					# note: headerlock & lock controlls fields which cannot be changed
					#	if something is delivered or produced from order

					$DATA['headerlock']	=	FALSE;

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['articalname'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
						$DATA['price'][]	=	$RESULT['price'];
						$DATA['tax'][]		=	$RESULT['tax'];

						if (($RESULT['date_of_delivery']) or ($RESULT['productionorderID']))	{

							$DATA['locked'][]	=	TRUE;

							if (! $DATA['headerlock']) $DATA['headerlock'] = TRUE;
						
						}	else	  {
	
							$DATA['locked'][]	=	FALSE;
						}
					}

				}	else	  {

					$DATA	=	'unexistentorder';
				}				
			}

			$this->unlock();

			return $DATA;
		}
	}
?>
