<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag customers payments write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('is_real_positive');

	load_f('date2sql');

	load_f('datecompare');

	class PAYMENTSWRITE	{

		function __construct()	{

			global $__SQL, $__CONF;
	
			$this->SQL	=	&$__SQL;
	
			$this->FORMAT	=	$__CONF->get('date', 'dateformat');

			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.addressbook WRITE, 
								$this->BASE.customers_payments WRITE		");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function write($DATA)	{

			if  (	(! isset($DATA['contactIDs'])) or (! $DATA['contactIDs']) or
				is_empty($DATA['paymentID']) or
				is_empty($DATA['bank']) or
				(! is_real_positive($DATA['sum']))) return 'usererror';

			$contactID	=	$this->SQL->escape($DATA['contactIDs']);

			$bank		=	$this->SQL->n_escape($DATA['bank']);
			
			$account	=	$this->SQL->n_escape($DATA['account']);

			$comment	=	$this->SQL->n_escape($DATA['comment']);
	
			$paymentID	=	$this->SQL->n_escape($DATA['paymentID']);

			$sum		=	$DATA['sum'];

			$date		=	date2sql($DATA['date'], $this->FORMAT);

			if (! $date) return 'dateerror';

			if (datecompare($date, '>', date("Y-m-d"))) return 'datebiggerthannow';

			$this->lock();

			# check contact

			$this->SQL->query("	SELECT `contactname`, `city` 
						FROM $this->BASE.addressbook
						WHERE `personID`='$contactID' AND `deleted` IS NOT NULL	");
			
			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'unexistentcontact';
			}

			$RESULT		=	$this->SQL->RESULT->fetch_row();

			$contactname	=	$this->SQL->nr_escape($RESULT[0]);

			$city		=	$this->SQL->nr_escape($RESULT[1]);

			$this->SQL->query("	INSERT INTO $this->BASE.customers_payments
						VALUES 
						(NULL, '$contactID', $contactname, $city, $paymentID, '$date', '$sum', $bank, $account, $comment, '0')	");

			$this->unlock();

			return TRUE;
		}
	}
?>
