<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**	
	 * eBag production order close
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('is_real_positive');

	load_f('is_int_positive');

	load_f('datecompare');

	load_f('date2sql');

	class PRODUCTIONORDERCLOSE	{
	
		var	$STOCKTABLES = array(1=>'finished_goods_stock', 2=>'operating_suplies');

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';

			$this->UNIT		=	new UNITloader($__CONF->get('cache', 'use_apc_cache'));

			$this->FORMAT		=	$__CONF->get('date', 'dateformat');
			
			$this->AUTOFINISH	=	FALSE;
		}

		private function lock()	{
		
			$tables_for_auto_finish = '';
		
			if ($this->AUTOFINISH)	{
			
				$tables_for_auto_finish = "	$this->BASE.employees WRITE,
								$this->BASE.addressbook WRITE,	";
			}

			$this->SQL->query("	LOCK TABLES	$this->BASE.production_orders_header WRITE, 
								$this->BASE.production_orders_data WRITE,
								$this->BASE.production_orders_phases WRITE,
								$this->BASE.orders_data WRITE, 
								$tables_for_auto_finish
								$this->STOCKBASE.finished_goods_stock WRITE,
								$this->STOCKBASE.operating_suplies WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}
		
		private function autofinish($ID)	{
		
			$phaseID = FALSE;
		
			$this->SQL->query("	SELECT MAX(`personID`) 
						FROM $this->BASE.production_orders_phases
						WHERE `productionorderID`='$ID'");
						
			if ($this->SQL->num_rows())	{

				$RESULT		= $this->SQL->RESULT->fetch_row();

				$phaseID	= $RESULT[0];
			}
			
			if (! $phaseID) return 'unexistentproductionorder';
			
			# check maybe it is already closed
			
			$this->SQL->query("	SELECT `personID`
						FROM $this->BASE.production_orders_phases
						WHERE `personID`='$phaseID' AND `finisher` IS NOT NULL AND `date` IS NOT NULL LIMIT 1	");
						
			if ($this->SQL->num_rows()) return TRUE;
			
			# read first employee or cooperator as finisher
			
			$finisherID = FALSE;
			
			$this->SQL->query("	SELECT `personID`
						FROM $this->BASE.employees
						WHERE `deleted` IS NOT NULL LIMIT 1	");
			
			if ($this->SQL->num_rows()) {
			
				$RESULT		= $this->SQL->RESULT->fetch_row();

				$finisherID 	= $this->SQL->escape("employee_{$RESULT[0]}");
				
			}	else	  {
			
				$this->SQL->query("	SELECT `personID`
							FROM $this->BASE.addressbook 
							WHERE `contacttype`='4' AND `deleted` IS NOT NULL LIMIT 1	");
							
				if ($this->SQL->num_rows()) {
				
					$RESULT		= $this->SQL->RESULT->fetch_row();

					$finisherID 	= $this->SQL->escape("cooperator_{$RESULT[0]}");
				}
			}
			
			if (! $finisherID) return 'nofinishers';
			
			# close last phase
			
			$now = date("Y-m-d");
			
			$this->SQL->query("	UPDATE $this->BASE.production_orders_phases
						SET `finisher`='$finisherID', `process_time`='1', `date`='$now'
						WHERE `personID`='$phaseID' LIMIT 1	");
		
			return TRUE;
		}

		public function close($DATA)	{

			$productionorderID	=	$this->SQL->escape($DATA['productionorderID']);

			$date_of_finishing	=	$DATA['date_of_finishing'];

			$defective_quantity	=	$DATA['defective_quantity'];
			
			if (isset($DATA['autofinish']) && $DATA['autofinish']) $this->AUTOFINISH = TRUE;

			# start transaction

			$this->SQL->transaction();
		
			$this->lock();

			# check delivered is & existens

			$this->SQL->query("	SELECT `stocktype`, `orderID`, `code`, `quantity`, `date_of_creation`, `date_of_finishing`
						FROM $this->BASE.production_orders_header
						WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1		");


			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentproductionorder';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			if ($RESULT['date_of_finishing']) {$FINISHED = TRUE;} else {$FINISHED = FALSE;}

			$STOCKTABLE		=	$this->STOCKTABLES[$RESULT['stocktype']];
			
			$orderID		=	$RESULT['orderID'];
	
			$articalcode		=	$this->SQL->nr_escape($RESULT['code']);

			$articalquantity	=	$RESULT['quantity'];

			$date_of_creation	=	$RESULT['date_of_creation'];

			# Set last phase finished by first employee
			
			if ($this->AUTOFINISH)	{
			
				$RESULT = $this->autofinish($productionorderID);
				
				if ($RESULT !== TRUE)	{
				
					$this->SQL->rollback();

					$this->unlock();

					return $RESULT;
				}
			}
			
			unset($RESULT);

			# read articals unit

			$this->SQL->query("	SELECT `unit`
						FROM $this->STOCKBASE.$STOCKTABLE
						WHERE `code`=$articalcode AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT		=	$this->SQL->RESULT->fetch_row();

				$articalunit	=	$RESULT[0];
			}
			
			if ($orderID)	{
			
				# if the production is to customer check that is not delivered yet

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.orders_data 
							WHERE `productionorderID`='$productionorderID' AND `date_of_delivery` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'deliveredorderitem';
				}
			}

			if (! is_empty($date_of_finishing))	{

				# close production order

				# check the last phase is finished

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.production_orders_phases
							WHERE `productionorderID`='$productionorderID' AND `date` IS NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$this->SQL->rollback();

					$this->unlock();

					return 'lastphaseisnotfinished';
				}

				# check number of defectives

				if ((isset($defective_quantity)) && (! is_empty($defective_quantity)) && ($defective_quantity!=0))	{

					if ($this->UNIT->is_int_unit($articalunit))	{

						if (! is_int_positive($defective_quantity)) $errtxt = 'usererror';
						
					}	else	 {

						if (! is_real_positive($quantity)) $errtxt = 'usererror';
					}

				}	else	  {

					$defective_quantity	=	0;
				}

				if ($defective_quantity > $articalquantity) $errtxt = 'usererror';

				# check date

				if (! isset($errtxt))	{

					$date_of_finishing = date2sql($date_of_finishing, $this->FORMAT);

					if (datecompare($date_of_finishing, '<', $date_of_creation)) $errtxt = 'dateerror';

				}

				if (isset($errtxt))	{

					$this->SQL->rollback();

					$this->unlock();

					return $errtxt;
				}

				if (! $FINISHED)		{

					# correct quantity with defectives

					$REAL_finished_quantity		=	(double)$articalquantity-(double)$defective_quantity;
					$REAL_in_production_quantity	=	$articalquantity;
					
					# change articles quantity in the stock if there is enough
					
					$not_enough_in_stock = FALSE;
					
					$this->SQL->query("	SELECT `code`, `quantity` 
								FROM $this->BASE.production_orders_data
								WHERE `productionorderID`='$productionorderID' AND `type`='a' AND `deleted` IS NOT NULL	");
								
					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					if ($this->SQL->num_rows())	{
					
						while($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

							$code		=	$this->SQL->nr_escape($RESULT['code']);
							
							$SUM 		= 	(double)$articalquantity*(double)$RESULT['quantity'];

							$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock 
										SET	quantity=quantity-$SUM, quantity_as_part=quantity_as_part-$SUM 
										WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
										
							$this->SQL->query("	SELECT `personID`
										FROM $this->STOCKBASE.finished_goods_stock
										WHERE `code`=$code AND `quantity`<0 AND `deleted` IS NOT NULL LIMIT 1	");
										
							if ($this->SQL->num_rows())	{
							
								$not_enough_in_stock = TRUE;
								
								break;
							}
						}
					}
					
					if ($not_enough_in_stock)	{
					
						$this->SQL->rollback();

						$this->unlock();

						return 'notenougharticle';
					}

				}	else	  {
				
					# Note: if the order is already closed the finished goods stock quantities are also already changed
					#	the feedstock quantities are updated only if the order is deleted 

					$closed_defectives		=	0;

					$this->SQL->query("	SELECT `defective_quantity` 
								FROM $this->BASE.production_orders_header
								WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1		");

					if ($this->SQL->num_rows())	{

						$RESULT			=	$this->SQL->RESULT->fetch_row();

						$closed_defectives	=	$RESULT[0];
					}

					$REAL_finished_quantity		=	(double)$closed_defectives-(double)$defective_quantity;

					$REAL_in_production_quantity	=	0;
				}

				# note: phase2 => Finished
	
				$this->SQL->query("	UPDATE $this->BASE.production_orders_header
							SET 	`finished`='1', `date_of_finishing`='$date_of_finishing', 
								`production_phase`='2', `defective_quantity`='$defective_quantity'
							WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1		");

				$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE
							SET 	quantity=quantity+($REAL_finished_quantity), 
								quantity_in_production=quantity_in_production-$REAL_in_production_quantity
							WHERE `code`=$articalcode AND `deleted` IS NOT NULL LIMIT 1	");

				$action	=	'closed';

			}	else	  {

				# open production order

				# get the last phase

				$this->SQL->query("	SELECT MAX(`personID`) 
							FROM $this->BASE.production_orders_phases
							WHERE `productionorderID`='$productionorderID' ");

				$phase	=	1;

				if ($this->SQL->num_rows())	{

					$RESULT		=	$this->SQL->RESULT->fetch_row();

					$phaseID	=	$RESULT[0];

					$this->SQL->query("	SELECT `production_phase` 
								FROM $this->BASE.production_orders_phases
								WHERE `personID`='$phaseID' LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$RESULT		=	$this->SQL->RESULT->fetch_row();

						$phase		=	$RESULT[0];
					}
				}

				# update the stock if not 

				if ($FINISHED)	{

					$closed_defectives		=	0;

					$this->SQL->query("	SELECT `defective_quantity` 
								FROM $this->BASE.production_orders_header
								WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1		");

					if ($this->SQL->num_rows())	{

						$RESULT			=	$this->SQL->RESULT->fetch_row();

						$closed_defectives	=	$RESULT[0];
					}

					$REAL_finished_quantity		=	(double)$articalquantity-(double)$closed_defectives;

					$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCKTABLE
								SET	quantity=quantity-$REAL_finished_quantity, 
									quantity_in_production=quantity_in_production+$articalquantity
								WHERE `code`=$articalcode AND `deleted` IS NOT NULL LIMIT 1		");
								
					# write back articles  into finished_goods_stock	
					
					$this->SQL->query("	SELECT `code`, `quantity` 
								FROM $this->BASE.production_orders_data
								WHERE `productionorderID`='$productionorderID' AND `type`='a' AND `deleted` IS NOT NULL	");
								
					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					if ($this->SQL->num_rows())	{
					
						while($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

							$code		=	$this->SQL->nr_escape($RESULT['code']);
							
							$SUM 		= 	(double)$articalquantity*(double)$RESULT['quantity'];

							$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock 
										SET	quantity=quantity+$SUM, quantity_as_part=quantity_as_part+$SUM 
										WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
						}
					}
				}
				
				# Note: if the order is already opened, the finished goods stock quantities will be unchanged
				#	the feedstock quantities are updated only if the order is deleted 

				$this->SQL->query("	UPDATE $this->BASE.production_orders_header
							SET 	`finished`='0', `date_of_finishing`=NULL, 
								`production_phase`='$phase', `defective_quantity`='0'
							WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1		");

				$action = 'opened';
			}

			$this->SQL->commit();

			$this->unlock();

			return $action;	
		}
	}
?>
