<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag service list delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SERVICELISTDELETE		{

		function __construct()	{

			global $__SQL;

			$this->SQL	=	&$__SQL;
			$this->BASE	=	$_SESSION['BASE'];
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.services_header WRITE, 
							$this->BASE.services_data WRITE, 
							$this->BASE.feedstock_requests WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function state($ID)	{

			$state	=	FALSE;

			$this->SQL->query("	SELECT `date_of_finishing`, `billID` 
						FROM $this->BASE.services_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				if (! is_empty($RESULT['date_of_finishing'])) $state = 'finishedrevers';

				if (! is_empty($RESULT['billID'])) $state = 'billedrevers';

				# check indents

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.feedstock_requests 
							WHERE `reversID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	$state = 'indentwithrevers';


			}	else	  {

				$state = 'unexistentrevers';
			}

			return $state;
		}


		public function delete($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();
		
			$this->lock();

			$STATE	= $this->state($ID);

			if ($STATE)	{

				$this->SQL->rollback();

				$this->unlock();

				return $STATE;
			}

			$delete_reason	=	$this->SQL->n_escape($DATA['delete_reason']);

			# delete header

			$this->SQL->query("	UPDATE $this->BASE.services_header
						SET `deleted`=NULL , `delete_reason`=$delete_reason 
						WHERE `personID`='$ID' LIMIT 1	");

			$this->SQL->query("	UPDATE $this->BASE.services_data 
						SET `deleted`=NULL 
						WHERE `reversID`='$ID'	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
