<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service list read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SERVICELISTREAD	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL	=	&$__SQL;
			
			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->BASE	=	$_SESSION['BASE'];
		}


		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}
	
		private function lock()	{

			$this->SQL->query("	LOCK TABLES	$this->BASE.services_header WRITE, 
								$this->BASE.services_data WRITE, 
								$this->BASE.feedstock_requests WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function state($ID)	{

			$state	=	FALSE;

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->query("	SELECT `date_of_finishing`, `billID` 
						FROM $this->BASE.services_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	=	$this->SQL->RESULT->fetch_assoc();

				if (! is_empty($RESULT['date_of_finishing'])) $state = 'finishedrevers';

				if (! is_empty($RESULT['billID'])) $state = 'billedrevers';

				# check request

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.feedstock_requests 
							WHERE `reversID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	return 'indentwithrevers';

			}	else	  {

				$state = 'unexistentrevers';
			}

			return $state;
		}

		public function read($ID)	{

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return 'unexistentrevers';

			# read

			$DATA	=	FALSE;

			$this->lock();

			$STATE = $this->state($ID);

			if ($STATE)	{

				$this->unlock();

				return $STATE;
			}

			# read header

			$this->SQL->query("	SELECT	`contactID`, `contactname`, DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(`date_of_deadline`, '$this->FORMAT') AS `date_of_deadline`, `service_discount`, `use_service_discount`,
							`session_discount`, `use_session_discount`, `payment_form`, `exchange_rate`, `currency`, `valuta`, `comment`, `annotation`
						FROM $this->BASE.services_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				# note adds year if is not current to display

				$DATA['service_list_year']	=	str_replace('ebagdata', '' , $this->BASE);

				# read data
		
				$this->SQL->query("	SELECT `code`, `servicename`, `quantity`, `unit`, `price`, `tax` 
							FROM $this->BASE.services_data 
							WHERE `reversID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` 	");

				if ($this->SQL->num_rows())	{

					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['price'] = $DATA['tax'] = array();
				
					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['servicename'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
						$DATA['price'][]	=	$RESULT['price'];
						$DATA['tax'][]		=	$RESULT['tax'];
					}

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			if (! $DATA) {return 'unexistentrevers';} else {return $DATA;}
		}
	}
?>
