<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag operating suplie request details read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SUPLIEREQUESTDETAILS	{

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
	
			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];
		}

		public function base($BASE)	{

			$this->BASE	=	$BASE;
		}

		private function lock()		{

			$this->SQL->query("	LOCK TABLES	$this->BASE.suplie_request_header WRITE, 
								$this->BASE.suplie_request_data WRITE,
								$this->BASE.employees WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$ID	=	$this->SQL->escape($ID);

			# first check te gived base exists or not

			$this->SQL->query("SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;

			$DATA	=	FALSE;

			$this->lock();

			$this->SQL->query("	SELECT	DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							`employeeID`, `comment`
						FROM $this->BASE.suplie_request_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$DATA	=	$this->SQL->RESULT->fetch_assoc();

				$DATA['request_year'] = str_replace('ebagdata', '' , $this->BASE);

				$employeeID	=	$DATA['employeeID'];

				$this->SQL->query("	SELECT `employeename`
							FROM $this->BASE.employees
							WHERE `personID`='$employeeID' AND `deleted` IS NOT NULL	");

				if ($this->SQL->num_rows())	{

					$RESULT = $this->SQL->RESULT->fetch_row();

					$DATA['employeename'] = $RESULT[0];

				}	else	{

					$DATA['employeename'] = $this->LANG->get('employeedeleted');
				}
	
				$this->SQL->query("	SELECT  `code`, `name`, `quantity`, `unit`
							FROM $this->BASE.suplie_request_data
							WHERE `requestID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{

					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = array();
				
					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
					}

				}	else	  {

					$DATA	=	FALSE;
				}
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
