<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	load_f('is_longer');
	 
	class USERWRITE	{

		var $USERID	=	FALSE;

		function __construct()	{

			global $__SQL;
	
			$this->SQL	=	&$__SQL;
			$this->BASE	=	'ebag';
			
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES $this->BASE.users WRITE");
		}

		private function unlock() {

			$this->SQL->query('UNLOCK TABLES');
		}

		private function prepare($DATA, $UPDATE=FALSE)	{

			if  (	 (is_empty($DATA['surname'])) or
				 (is_empty($DATA['lastname'])) or
				 (is_empty($DATA['username'])) or
				 (is_longer($DATA['username'], 30)) or
				 (is_empty($DATA['password']))	) return 'usererror';

			# accept digits, unicode letters, _ and &

			if (! preg_match('/^[\w\&]+$/iu', $DATA['username'])) return 'onlylettersandnumbers';

			if (	(! $UPDATE) or 
				(($UPDATE) && ($DATA['password']!='*****')))	{

				if (! preg_match('/^[\w\&]+$/iu', $DATA['password'])) return 'onlylettersandnumbers';
			}

			foreach ($DATA as $key=>$val)	{

				if ($key != 'password') $DATA[$key] = $this->SQL->n_escape($val);
			}

			if (! $UPDATE) $DATA['password'] = md5($DATA['password']);

			return $DATA;
		}

		/**
		 * returns new user id
		 */

		public function getnewuserid()	{

			return $this->USERID;
		}

		public function write($DATA)	{

			$DATA	=	$this->prepare($DATA);

			if (! is_array($DATA)) return $DATA;

			$this->SQL->transaction();

			$this->lock();

			extract($DATA); unset($DATA);

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.users 
						WHERE `username`=$username AND `deleted` IS NOT NULL");

			if ($this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'userexists';
			}

			# create new permission read for all

			$permission = 'addressbook=1/discounts=1/services=1/feedstock=1/operating_suplies=1/stock=1/service_lists=1/offers=1/orders=1/orders_to_stock=1/production=1/deliverys=1/bills=1/payments=1/summ_for_customer=1/employees=0/salarys=0/settings=0/users=0';

			$permission = $this->SQL->n_escape($permission);

			# insert user

			$this->SQL->query("	INSERT INTO $this->BASE.users 
						VALUES 
						(NULL, $surname, $lastname, $username, '$password', $mail, $permission, '0')"	);

			$this->USERID	=	$this->SQL->lastid();

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}

		public function update($ID, $DATA)	{

			$DATA	=	$this->prepare($DATA, TRUE);

			if (! is_array($DATA)) return $DATA;

			$this->SQL->transaction();

			$this->lock();

			extract($DATA); unset($DATA);

			# check the record exists

			$this->SQL->query("	SELECT `username` 
						FROM $this->BASE.users 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'deletedinmeantime';
			}

			# check changed username exists
			
			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.users 
						WHERE `username`=$username AND `personID`!='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'userexists';
			}

			# update the password
			# note: is important that the value '*****' be send from view to know about password change

			if ($password != '*****')	{

				$password	=	md5($password);

				$this->SQL->query("	UPDATE $this->BASE.users 
							SET `password`='$password' 
							WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
			}

			# update the rest

			$this->SQL->query("	UPDATE $this->BASE.users
						SET `surname`=$surname, `lastname`=$lastname, `username`=$username, `mail`=$mail
					  	WHERE `personID`=$ID AND `deleted` IS NOT NULL LIMIT 1");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}

	}

?>
