<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new order to stock item js fill request
	 */

	if ((! isset($_GET['code'])) or (! isset($_GET['type'])) or (! isset($_GET['base']))) exit;
	
	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# If magic quotes is enabled strip slashes from code

	if (get_magic_quotes_gpc())	{

		foreach ($_GET as $key=>$val) $_GET[$key] = stripslashes($val);
	}

	$code	=	$_GET['code'];
	$type	=	$_GET['type'];
	$BASE	=	$_GET['base'];

	$TYPES	=	array(	1	=>	'finished_goods_stock',
				2	=>	'feedstock'	);

	$STOCK 	=	$TYPES[$type];

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# Sets session handler

	include('../classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();
	
	# Check for session protect from unathorized access
	
	if (! isset($_SESSION['permission'])) exit;

	# create connection

	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));
	
	if ($mysqli->connect_error) exit;

	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");

	$code	=	$mysqli->real_escape_string(htmlspecialchars($code, $__CONF->get('specialchars', 'flag'), 'UTF-8', FALSE));

	# read item data

	$RESULT	=	$mysqli->query("	SELECT `quantity`, `supplierID`, `supplier` FROM ebagstock.$STOCK
						WHERE `code`='$code' AND `origin`!='1' AND `deleted` IS NOT NULL LIMIT 1");

	if (! $RESULT->num_rows) exit;

	$ROW	=	$RESULT->fetch_row();

	$stockquantity		=	$ROW[0];
	$supplierID		=	$ROW[1];
	$supplier		=	$ROW[2];
	$order2stockID		=	'-';
	$orderedquantity	=	'-';

	# check exist opened order to stock

	$RESULT	=	$mysqli->query("	SELECT `personID` FROM $BASE.orders_to_stock_header
						WHERE `supplierID`='$supplierID' AND `ordered`='0' AND `deleted` IS NOT NULL LIMIT 1	");
	
	if ($RESULT->num_rows)	{

		$ROW	=	$RESULT->fetch_row();
		
		$order2stockID	=	$ROW[0];

		$RESULT	=	$mysqli->query("	SELECT `quantity` FROM $BASE.orders_to_stock_data
							WHERE `order2stockID`='$order2stockID' AND `code`='$code' AND `ordered`='0' AND `deleted` IS NOT NULL LIMIT 1	");

		if ($RESULT->num_rows)	{

			$ROW	=	$RESULT->fetch_row();

			$orderedquantity 	=	$ROW[0];

		}	else	 {

			$order2stockID		=	'-';
		}
	}

	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT'); 
	header('Last-Modified: '.@gmdate( 'D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/xml');

	echo  	'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n"
		."<response>\r\n<data><supplier>$supplier</supplier>\r\n<supplierID>$supplierID</supplierID>\r\n<order2stockID>$order2stockID</order2stockID>\r\n<stockquantity>$stockquantity</stockquantity>\r\n<orderedquantity>$orderedquantity</orderedquantity>\r\n</data></response>";

?>
