<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag reads order to stock to fill enter form
	 */
	 
	if ((! isset($_GET['base'])) or (! isset($_GET['id']))) exit;

	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# If magic quotes is enabled strip slashes from code

	if (get_magic_quotes_gpc())	{

		foreach ($_GET as $key=>$val) $_GET[$key] = stripslashes($val);
	}

	$order2stockID	=	$_GET['id'];
	$BASE		=	$_GET['base'];

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# Sets session handler

	include('../classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();
	
	# Check for session protect from unathorized access
	
	if (! isset($_SESSION['permission'])) exit;
	
	# create connection

	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));

	if ($mysqli->connect_error) exit;

	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");

	$order2stockID	= $mysqli->real_escape_string(htmlspecialchars($order2stockID, $__CONF->get('specialchars', 'flag'), 'UTF-8', FALSE));

	$FORMAT = $__CONF->get('date', 'sql_format');

	# read item data

	$RESULT	=	$mysqli->query("	SELECT `contactname`, 
						DATE_FORMAT(`date_of_order`, '$FORMAT') AS `date_of_order`
						FROM $BASE.orders_to_stock_header
						WHERE `personID`='$order2stockID' AND `deleted` IS NOT NULL LIMIT 1	");
	if (! $RESULT->num_rows) exit;

	$ROW	=	$RESULT->fetch_row();

	$supplier		=	$ROW[0];
	$date_of_order		=	$ROW[1];

	if (! $date_of_order) exit;

	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT'); 
	header('Last-Modified: '.@gmdate( 'D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/xml');

	echo  	'<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n"
		."<response>\r\n<data><supplier>$supplier</supplier>\r\n<date>$date_of_order</date>\r\n</data></response>";

?>

